(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





Needs["OreAlgorithms`"];

BeginPackage["GroebnerWalk`"];



Needs["OreAlgorithms`"];
Needs["Ore`"];











Clear[RefinedOrder];
RefinedOrder[w_/;Or@@(Thread[w!=0]),B_/;Det[B]=!=0]:=Module[
      {l,n,Result},
      l=n=Length[B]; (* Number of Line to drop *)
      
      Result=Prepend[Drop[B,-1],w]; 
      While[ Det[Result]\[Equal]0,
        n=n-1; 
        Result=
          Flatten[{{w},Take[B,(n-1)],Drop[B,n]},1];
        ];
      Return[Result];
      ];



Clear[SortOrePolynomials];
SortOrePolynomials[G_List,verbosity_Integer:0]:= Sort[G,#1>#2&];



Clear[TakeInitials];
TakeInitials[G_List]:=
    Map[OreInitialTerm[#]&,G];



Clear[InitGB];
InitGB[G_List,verbosity_Integer:0]:=
    Module[{ifo,rGB},
      InfoMessage[verbosity,5,"Entering InitGB"];
      ifo=TakeInitials[G]; (* Get initial forms. *)
      
      InfoMessage[verbosity,4,"Initials:", ifo];
      rGB=OreLeftGroebner[ifo];
      InfoMessage[verbosity,4,"their Gr\[ODoubleDot]bnerbase:\n",rGB];
      rGB
      ];



Clear[Interreduce];
Interreduce[G_List,v_:0]:=OreReduceGroebnerBasis[G,v];





Clear[LiftUp];
LiftUp[Gw_List,G_List,{order__},verbosity_Integer:0]:=
    
    Module[{oldorder,ret},
      InfoMessage[verbosity,3,"Entering LiftUp:"];
      oldorder=OreOrderData[];
      OreRedefineMonomOrder[order];
      ret=Map[#-OreDivision[#,OreSimplify/@G][[1]]&,OreSimplify/@Gw];
      OreRedefineMonomOrder[oldorder];
      ret=OreSimplify/@ret
      ];









Clear[DoTheWalk];
DoTheWalk::"B singular"="Singular destination order matrix `1`.";

DoTheWalk[G_List,DestOrder_/;MatrixQ[DestOrder], verbosity_Integer:0,
    maxsteps_:Infinity]:=
  Module[{aO, (* aO: Actual Ordermatrix here. *)
      
      GG,(* The actual Basis on the walk. *)
      
      Gw,(* The initalforms of the Elements of GG. *)
      
      Gwp ,(* Sorted Gw / new gr\[ODoubleDot]bnerbase. *)
      
      vars, (* Current variable list. *)
      A, (* Startorder. *)
      
      B=DestOrder, (* Destination order. *)
      
      v, (* The initialform of the destinationorder. *)
      
      w, (* Initialform of actual order on the walk. *)
      
      t, (* ratio from the last weight to the destination. *)
      
      Ordervectors, (* The vectors according to all monomials. *)
      
      step=0 (* actual step of the Walk. *)
      }, 
    Catch[
      If[Det[B]\[Equal]0,Message[DoTheWalk::"B singlular",B];Abort[] ];
      InfoMessage[verbosity,3,"Entering DoTheWalk:",G,DestOrder];
      
      (* 1. Initialisation *)
      
      {vars, A}={OreOrderData[]};
      w=First[A];v=First[B];
      
      GG=G;(* Start with the given gr\[ODoubleDot]bnerbase. *)
      
      InfoMessage[verbosity,3,"Initialized: v,w,g=",v,w,GG];
      
      While[True, (* main loop *)
        
        InfoMessage[verbosity,0,
          Print["Check, whether actual GG is still a Gr\[ODoubleDot]bner base: Current matrix is:",
            OreCurrentMatrix];
          If[OreIsLeftGroebner[GG],"It is.", Print["No! Exit."]; 
            OreRedefineMonomOrder[vars, A];Throw[{"Walk Failed!",GG}]]];
        
        step=step+1;
        
        lastorder=OreOrderData[];(* remember last order *)
        
        aO= RefinedOrder[w,B];(* Next Order: *)
        
        OreRedefineMonomOrder[vars, aO]; (* Setting the new Order. *)
        
        InfoMessage[verbosity,1,"New order matrix is:",OreCurrentMatrix,"."];
        GG=(OreSimplify/@GG); (* Re-sort the Objects. *)
        
        InfoMessage[verbosity,2,"last order: ",{lastorder}[[2]]//MatrixForm, 
          "actual order: ", OreCurrentMatrix//MatrixForm, "Gb now: ",GG];
        
        (* 2.  get the initialpolynomials: *)
        Gw=TakeInitials[GG];
        InfoMessage[verbosity,2,"Step 2, Initial forms:",Gw];
        
        (* 3.  sort according to new order. *)
        
        Gwp=SortOrePolynomials[Gw];
        InfoMessage[verbosity,2,"Step 3: Sorted, now Gwp=",Gwp];
        
        (* 4.  Calculate Groebnerbasis. *)
        
        InfoMessage[verbosity,2,"Step 4: Calculating GB of initials:"];
        Gwp=InitGB[Gwp,verbosity];
        InfoMessage[verbosity,3,"It is:",Gwp];
        
        (* Interreduction leads here to failures;
          (* 5.  interreduction. *)
          Gwp=Interreduce[Gwp];
          *)
        
        (* 6.  Lift to a gr\[ODoubleDot]bnerbasis. *)
        
        GG=LiftUp[Gwp,GG, {lastorder}, verbosity];
        InfoMessage[verbosity,2,"Step 6: Gwp now lifted: GG=",GG];
        
        (* 7.  interreduction. *)
        GG=Interreduce[GG];
        InfoMessage[verbosity,2,"Step 7: Gwp reduced: GG=",GG];
        
        (* 8.  are we ready? *)
        
        InfoMessage[verbosity,2,"Step 8: Ready? ",w===v];
        If[w===v, Return[GG]];
        
        (* 9.  search new border. *)
        (*Ordervectors= TakeVectors[GG];
          
          InfoMessage[verbosity,3,"Step 9. GG, Ordervectors:",GG," : ",
            Ordervectors];*)
        
        {w,t}=NextDegeneration[GG,v];
        
        InfoMessage[verbosity,2,"Step 9: New weight determined."];
        InfoMessage[verbosity,3,"t=",t," weight=",w];
        If[t==2, Return[GG]];
        
        (* 10. prepare next iteration.*)
        (* w= (1-t)w+t v; *)
        
        InfoMessage[verbosity,3,"Next weight vector: w=",w];
        If[step>=maxsteps, Return[]];
        InfoMessage[verbosity,2,"Entering iteration ",step+1];
        ]; (* While *)
      ]
    ];

EndPackage[];