(*
Ore Algebra Basispaket
*)
(*
Basisroutinen zum rechnen in Ore-Algebren 
*)
(*
History
*)
(*
30.01.06: Rechtschreibkorrekturen ... 
16.06.05: Umwandlung in pr\[ADoubleDot]sentationsform, Privacy \
wiederhergestellt.
 26.04.05: Bug in OreContent beseitigt (GCD statt PolynomialGCD).
  07.03.05: Inhaltsfunktion bez\[UDoubleDot]glich Operatorvariablen als \
OreVarContent und OreVarEliminateContent implementiert.
  22.02.05: Bug in OperatorPowerTimesSummand f\[UDoubleDot]r Diff beseitigt.
  24.12.04: changed: OreLeadingMonomial->OreLeadingOperatorMonomial.
  24.12.04: denn es ist nur der Operatoranteil des Leitmonomes.
  24.12.04: Neu: OreLeadingMonomial ist korrekt das Leitmonom.
            13.10.04 : OreHasNoOperators implementiert. OreCurrentMatrix
                wird nun initialisiert
  12.10.04 : OreExponent implementiert, OreIsMonicQ korrigiert.
  09.10.04 : OreCoefficientList gibt wirklich die Koeffizienten aus
              statt der Variablen.
  
  07.10.04 : OMu auch als un\[ADoubleDot]re Operation zugelassen.    
  06.10.04 : fehlendes UpdateCounter in DeclareVariables \
eingef\[UDoubleDot]gt.
  31.08.04 : usage-Informationen ausgebaut. 
  21.05.04 : Beschreibungen der "***DefineOrder"-Befehle erg\[ADoubleDot]nzt
  05.04.04 : Bug in OreMultiplication beseitigt
  05.04.04 : Multiplizieren mit OreZero lieferte Unsinn
  29.03.04 : OreInitialTerm[x_OrePolynomial] implementiert
  23.03.04 : OreGetMonomOrder, OreOrderData mit den Operationen
  23.03.04 : OreDefine... angepasst, Datenstruktur angepasst.
  17.03.04 : S-Polynom berichtigt, Ordnungsfunktionen zugef\[UDoubleDot]gt
  06.05.02 : Multiplikation neugeschrieben. 
  29.04.02 : Bug in OreVarMonomialQ beseitigt. 
  04.04.02 : Vektorordnungen implementiert, intern
  03.04.02 : Umwandlung von OreSummanden in Vektoren, um 
            die Ordnung darueber implementieren zu koennen.;
  26.03.02: 
    Implementiert: OreVarMonomialQ OreExtendedExp2Vec OreExp2Vec OreVec2OPo
  25.03.02: Design\[ADoubleDot]nderung: Zu den Operatoren kommt nun noch eine \
Liste Gradrelevanter Variablen
  13.06.01 : Ausbau auf mehrere Operatoren auf einer Variablen
  ... ;
*)
(*
  ToDo:                                        
	OreContent so ausbauen, da\[SZ] auch Parameter ber\[UDoubleDot]cksichtigt \
werden.
  F\[UDoubleDot]r den Gr\[ODoubleDot]bner-Walk:                               \
        
  To Check:
  OreVersion up Date?
  OreContent sollte mit Parametern (die keine Ore Variablen sind) \
zurechtkommen.
*)
(*
Deklarationen und Schnittstelle f\[UDoubleDot]r den aufrufenden Kontext.
*)
BeginPackage["Ore`"];
OreApply::usage = "OreApply[_OrePolynomial,_] 
Applies the Given OrePolynomial as an Operator on the second Argument.";
Delta::usage = "The Map Delta[i], extended on Polynomials.If 'Op' is the i-th Operator, then Op f = \[Sigma][f]Op + \[Delta][f]. Where \[Delta]=Delta[i]";
  
NextDegeneration::usage = " NextDegeneration[L_List, v_List] gets the next Degenerationpoint of the List L of ore polynomials when wandering from the current order to the order with the wightvector v.";
  
NextDegenerationVec::usage = " NextDegenerationVec[L_List, v_List] gets the next Degenerationpoint of the List L of Vectors when wandering from the current order to the order with the wightvector v.";
  
Operation::usage = "The actual Operations Operation[i] as Functions.";
OreCoefficientList::usage = "OreCoefficientList[P_OrePolynomial] gives a list consisting of the coefficients of P.";
  
OreContent::usage = "OreContent[P_OrePolynomial] returns the GCD of the coefficients of P, using the common GCD-Command from mathematica (i.e. assuming commutativity of the basering)";
  
OreCurrentMatrix::usage = 
    "OreCurrentMatrix[] Returns the Matrix of the actual Monomorder together with a List of the ordered Objects defining the canonical Order.";
  
OreDefineLexOrder::usage = "Usage: OreDefineLexOrder Switches to (default) lexicographical Order. Other orders: OreDefineReverseLexOrder, OreDefineDegLexOrder, OreDefineReverseDegLexOrder.";
  
OreDefineReverseLexOrder::usage = "Usage: OreDefineReverseLexOrder[] Switches to the Inverse lexicographical Order. Other orders: OreDefineLexOrder, OreDefineDegLexOrder, OreDefineReverseDegLexOrder";
  
OreDefineDegLexOrder::usage = "Usage: OreDefineDegLexOrder[] Switches to the Degree lexicographical Order.OreDefineReverseLexOrder, OreDefineLexOrder, OreDefineReverseDegLexOrder";
  
OreDefineReverseDegLexOrder::usage = "Usage: OreDefineReverseDegLexOrder[] Switches to the Degree (double)reverse lexicographical Order.Other orders: OreDefineReverseLexOrder, OreDefineDegLexOrder, OreDefineLexOrder.";
  
OreDeclareVariables::usage = "OreDeclareVariables[L_List] Takes the not jet declared Variables from L and appends them to the List of already declared Variables.
    See also: OreDefineOperator, OreDefineShift, OreDefineDiff, OreDefineQDifferentiation, OreDefineDummy.";
  
OreDefineOperator::usage = "OreDefineOperator[_Symbol,_List, _List,_Function] : Set up the local Definitions for Sigma, Delta of a new Operator, appends it on the List of Operators and returns an ore polynomial cosisting of the new Operator. The first argument denotes the Name of the Operator shown in the Output. The first List is a List of Rules defining The Algebrahom. \[Sigma], for example {X -> 3, Y->X, Z->Z}. The second List is the same with \[Delta], the third Parameter describes the Operation. For \[Sigma] != id it is sufficient to give the image of \[Delta] for the first Variable X with \[Sigma](X)!=X, because \[Delta] is fully dertermined with this data. Consistency will not be checked!
See also: OreDeclareVariables, OreDefineShift, OreDefineDiff, OreDefineQDifferentiation, OreDefineDummy.";
  
OreDefineShift::usage = 
    "OreDefineShift[_Symbol, _Symbol] : Set up the local Definitions for Sigma, Delta of a new shift operator, appends it on the List of Operators and returns an ore polynomial cosisting of the new operator. The first argument denotes the Name of the Operator shown in the Output. The second argument says, wich Variable is shifted. Consistency will not be checked (for example violation of the Ore Condition that the Operators must commute)!";
  
OreDefineDiff::usage = 
    "OreDefineDiff[_Symbol, _Symbol] : Set up the local Definitions for Sigma, Delta of a new Differeniation operator, appends it on the List of Operators and returns an ore polynomial cosisting of the new operator. The first argument denotes the Name of the Operator shown in the Output. The second argument says, with respect to wich Variable is differentiated. Consistency will not be checked (for example violation of the Ore Condition that the Operators must commute)!";
  
OreDefineQDifferentiation::usage = 
    "OreDefineDiff[_Symbol, _Symbol,_Symbol] : Set up the local Definitions for Sigma, Delta of a new q-Differeniation operator, appends it on the List of Operators and returns an ore polynomial cosisting of the new operator. The first argument denotes the Name of the Operator shown in the Output. The second argument says, with respect to wich Variable is differentiated, the third stands for the Parameter 'q' of the q-Differentiation. Consistency will not be checked (for example violation of the Ore Condition that the Operators must commute)!";
  
OreDefineDummy::usage = 
    "OreDefineDummy[_Symbol] : Set up the local Definitions for Sigma, Delta of a new commutative operator, appends it on the List of Operators and returns an ore polynomial cosisting of the new operator. The argument denotes the Name of the Operator shown in the Output. Applying this Operator is just multiplying its argument as a commutative Variable.";
  
OreEliminateContent::usage = "OreEliminateContent[P_OrePolynomial] Devides by the Content
and simplifies the Coefficients.";
OreExponent::usage = \
"OreExponent[M_OrePolynomial/;OreObjectQ[M], S_OrePolynomial] Gives the maximal Power to wich M appears in one of the Summands of S.";\

(*"OreExtendedSummandLCM::usage = "OreExtendedSummandLCM[a_OreSummand, 
      b_OreSummand] Returns a list consisting of the least common multiple l \
of the oreSummands a, b as first element, and x, y with a*x = b*y = l.";"*)
OreExtendedSPolynomial::usage = "OreExtendedSPolynomial[p_OrePolynomial,q_OrePolynomial] returns the S-Polynomial and Monomials a,b with S=a*p + b*q in the Form {S,a,b}. ";
  
OreGetMonomOrder::usage = "OreGetMonomOrder[] gives the momentanary used momomorder. It returns a List {Variables,Matrix}. 'Variables' is a List containing all relevant Variables, thus defining a 'canonical Order'. 'Matrix' defines a matrix describing how the actual order is lead back to the canonical Order.
See also OreRedefineMonomOrder.";
(*" OreHasNoOperators::usage="OreHasNoOperators[P_] finds out, 
  whether P is an ore polynomial without any operators. ";"*)
OreInverse::usage = "Inverts an Operator if it is a Unit.";
OreIsMonicQ::usage = "OreIsMonicQ[P_OrePolynomial] Tests whether P is a simple Monomial.";
  
OreIsUnitQ::usage = "OreIsUnitQ[P_OrePolynomial] tests, if P is invertible.";
OreIsObjectQ::usage = "OreIsObjectQ[P] tests, whether P is an ore polynomial consisting of one single operator or ore variable.";
  
OreInitialTerm::usage = "OreInitialTerm[x_OrePolynomial]: Gives the Initial Term of x with respect to the first row of the actual order matrix.";
  
OreLeadingCoefficient::usage = "OreLeadingCoefficient[_OrePolynomial] returns
the leading coefficient of this polynomial.";
OreLeadingSummand::usage = "OreLeadingSummand[_OrePolynomial] returns
the leading Summand of this polynomial.";
OreLesserTerms::usage = "OreLesserTerms[p_OrePolynomial] returns the Polynomial without the Leading Term.";
  
OreLeadingMonomial::usage = "OreLeadingMonomial[f_OrePolynomial] returns the leading summand, divided by all non-ore-variable Constants";
  
OreLeadingOperatorMonomial::usage = "OreLeadingOperatorMonomial[_OrePolynomial] returns the Leading Monomial
of the given orepolynomial.";
OreListOfOrderObjects::usage = "A list of the objects concerned by the current order in internal Form. This is a raw form, to see the Variables in their actual canonical order, use OreOrderedListOfObjects. 
See also: OreOrderedListOfObjects.";
OMu::usage = "Short for OreMultiplication. ";
OPo::usage = "Make An Ore Polynomial from an Expression/OreSummand";
Ore::usage = "Functions to handle Expressions with Ore-Operators";
OreMapOnCoefficients::usage = "OreMapOnCoefficients[f_Function,P_OrePolynomial]
Applies the given Function on all Coefficients.l";
OreMonomial::usage = "OreMonomial[{n1,p1},{n2,p2}, ...,{ni,pi}] stands for the Product
of the pi-th Powers of Operator n1, ... Operator ni, n1 < n2 < ... ni .";
OreNumberOfObjects::usage = "This is OreNumberOfOperators + OreNumberOfVariables";
  
OreNumberOfOperators::usage = "This is the number of defined Operators.";
OreNumberOfVariables::usage = "This ist the number of declared Variables.";
OreOne::usage = " The One-Polynomial. ";
OreOneMonomial::usage = "The One-Monomial D^0";
OreOperatorNames::usage = "This is a list of the names of the Operators.";
OreOrderData::usage = "Giving a sequence of the currently used canonical order of objects and the current order matrix. This Sequence ist ready to be the Argument(s) of 'OreRedefineMonomOrder'.";
  
OreOrderedListOfObjects::usage = "OreOrderedListOfOrderObjects returns a list of variables and operators ordered according to the identity order.
See also: OreOrderData";
OrePolynomial::usage = " OrePolynomial[_OreSummand, _OreSummand, ...] denotes
an OrePolynomial in cannonical Form, i.e. sorted with respect to the Monomial
Order.";
OrePolynomialsToVectorList::usage =
    "OrePolynomialsToVectorList[L_List] Returns a List of all ordervectors of all summands occuring in the given list of orepolynomials.";
  
OreRedefineMonomOrder::usage = "Usage: OreRedefineMonomOrder[Monomials_List, Matrix_List]
This redefines the Monomial Order used. The first list must consist of The operators, wich should be considered in their canonical order (i.e. Dx, Dy, Dz for the canonical Order  Dx > Dy > Dz), the second is a Matrix A, defining the actual Order (such that in our example Dx^m Dy^n Dz^o < Dx^M Dy^N Dz^O is defined by 
(m,n,o).A < (M,N,O).A where the latter '<' denotes the lexicographical order.)
WARNING: After adding a new Operator, OreRedefineMonomOrder must be called again.
See also: OreOrderData";
OreSummand::usage = "OreSummand[_OreCoefficient,_OreMonomial] encapsulates a Polynomial 
Coefficient and an Ore Monomial.";
OreVariables::usage = "This is a list of the declared Variables of the Algebra.";
  
OreMultiplication::usage = "perform Multiplication of OrePolynomials";
OreShowStatus::usage = "Show all Operators, Variables and OrderInformation";
OreSimplify::usage = "OreSimplify[_OrePoly] Collects and sorts with respect
to the monomial Ordering.";
OreSimplifyCoefficients::usage = "Apply the mathematica - simplify to the
coefficients of an ore polynomial (assuming commutativity of the ring of coefficients).";
  
OreSPoly::usage = "OreSPoly[p_OrePolynomial,q_OrePolynomial] returns the S-Polynomial of Monomials p,q.";
  
OreTerm::usage = "OreTerm[x___] returns an ore polynomial consisting of the product of all arguments after translating them to Ore Polynomials.";
  
OreVarContent::usage = 
    "OreVarContent[P_OrePolynomial] gives the polynomial GCD of the coefficients of the operatormonomials.";
  
OreVarEliminateContent::usage = "OreVarEliminateContent[P_OrePolynomial] devides out OreVarContent[P] from the coefficients of the operatormonomials";
  
OreVarMonomialQ::usage = "OreVarMonomialQ[a_Expression] Tests, whether the Expression a is a Monomial in the Ore Variables.";
  
OreZero::usage = " The Zero-Polynomial. ";
OreZeroSummand::usage = "The summand zero";
Sigma::usage = "The Maps Sigma[i], extended on Polynomials. If 'Op' is the i-th Operator, then Op f = \[Sigma][f]Op + \[Delta][f]. Where \[Sigma]=Sigma[i]";
  
SolvableQ::usage = "SolvableQ tests, if The actual Order is of solvable type.";
  
SummandToVector::usage =
    "SummandToVector[f_OreSummand] translates an ore Summand into the internal ordervector. The i-th entry is the power to wich the i-th oreobject appears.";\

(*
Die Implementation.
*)
Begin["`Private`"]; 
(*
Aufbau der internen Datenstruktur.
*)
(*
Die interne Datenstruktur sieht im Detail wie folgt aus:
Die Objekte, mit denen der Anwender Arbeitet haben den Header 
OrePolynomial.
*)
(*
Initialisierung der Container f\[UDoubleDot]r die Ore-Objekte und die \
Ordnung, Buchhaltungsfunktionen.
*)
OreOperators = {};
OreVariables = {};
OreNumberOfOperators = 0;
OreNumberOfVariables = 0;
OreListOfOrderObjects = {};      (*" Ops & Vars "*)
OreNumberOfObjects := 
  OreNumberOfOperators + OreNumberOfVariables;
(*
Defaultm\[ADoubleDot]\[SZ]ig wird die interne Reihenfolge f\[UDoubleDot]r die \
Ordnung verwendet.
*)
OreOrderVector := Table[i, {i, OreNumberOfObjects}]; 
(*
Die Reihenfolge der Objekte f\[UDoubleDot]r die Ordnung kann mit folgender \
Permutation umgeordnet werden:
*)
OreInternalToActual := Table[i, {i, OreNumberOfObjects}]; 
(*
Die die aktuelle Ordnung definierende Matrix
*)
OreCurrentMatrix = {{}};
(*
Abk\[UDoubleDot]rzungen f\[UDoubleDot]r h\[ADoubleDot]ufige Objekte:
*)
OreOneMonomial := OreMonomial[]; (*" Das "Einsmonom" vom Grad 0 "*)
OreZero = 
  OPo[0];
OreZeroSummand = OreSummand[0, OreOneMonomial];
OreOne = OPo[1];
(*
Ausgabeformatierungen, um ein lesbares Polynomformat zu erhalten
*)
(*
Die folgenden Ausgabe\[ADoubleDot]nderungen sind eher provisorischer Natur. \
Es tauchen noch einige nicht so sch\[ODoubleDot]ne Ph\[ADoubleDot]nomene auf, \
Hauptnachteil f\[UDoubleDot]r die Anwendung ist das copy/paste nicht \
funktioniert.
*)
Format [OreOneMonomial] := ""; (*" Faktor 1 weglassen. "*)

Format [OreMonomial[x_]] ^:= (*" Einzelne Potenz Darstellen. "*)
    
    OreOperatorNames[x[[1]]]^x[[2]];
Format [OreMonomial[x__]] ^:= (*" Mehrere Potenzen hintereinanderschreiben. "*)

        Infix[
      Map[OreOperatorNames[#1]^#2 & @@ Sequence[#] &, {x}]
      , ""];
Format[OreSummand[x_, OreOneMonomial]] ^:= x;
Format[OreSummand[1, m_OreMonomial]] ^:= m; (*" skip Factor One. "*) 
Format[x_OreSummand] ^:= Infix[x , ""];

Format[OrePolynomial[x_OreSummand]] ^:= x;
Format[OrePolynomial[x__OreSummand]] ^:=
    Infix[OrePolynomial[x], "+"];
(*
Hier ist die eigentliche Ausgabeformatierung beendet. Es folgt ein Format f\
\[UDoubleDot]r die nichtausgef\[UDoubleDot]hrte
Ore-Multiplikation. Eine nicht ausgef\[UDoubleDot]hrte Multiplikation von \
Ore-Objekten weist aber im Allgemeinen
auf einen Fehler bei den Berechnungen hin.
*)
Format[OreMultiplication[x__]] ^:= Infix[OreMultiplication[x], "*@*"]
(*
Attribute der Datenstrukturen.
*)
(*
OrePolynome als reine Container sind nicht zu schachteln: \
OPo[x,OPo[y]]=OPo[x,y],
OreMonome werden obendrein stets sortiert dargestellt: Operatorvariablen \
unter sich kommutieren!
*)
SetAttributes[OrePolynomial, Flat];
SetAttributes[OreMonomial, {Flat, Orderless}];
(*
Funktionen um Auskunft \[UDoubleDot]ber den aktuellen Zustand zu geben.
*)
(*
Die Objekte in der momentan gew\[ADoubleDot]hlten Reihenfolge:
*)
OreOrderedListOfObjects := Table[
      OreListOfOrderObjects[[
          OreOrderVector[[i]]
          ]], {i, 1, OreNumberOfObjects}
      ];
(*
Der Gesamtstatus der Datenstruktur:
*)
OreShowStatus := (
      Print[" OreNumberOfVariables: ", OreNumberOfVariables];
      Print[" OreNumberOfOperators: ", OreNumberOfOperators];
      Print[" OreNumberOfObjects: ", OreNumberOfObjects];
      Print["OperatorNames: ", 
        Table[OreOperatorNames[i], {i, 1, OreNumberOfOperators}]];
      Print["\[Sigma]`s: ", Table[Sigma[i], {i, 1, OreNumberOfOperators}]];
      Print["\[Delta]`s: ", Table[Delta[i], {i, 1, OreNumberOfOperators}]];
      Print["\[Delta]`s: ", 
        Table[OreOperatorNames[i], {i, 1, OreNumberOfOperators}]];
      Print["OperatorVariables: ", 
        Table[OreVariables[[i]], {i, 1, OreNumberOfVariables}]];
      Print["OreOperators: ", 
        Table[OreOperators[[i]], {i, 1, OreNumberOfOperators}]];
      Print["OreListOfOrderObjects: ",
        OreListOfOrderObjects];
      Print["In current 'canonical Order': ",
        OreOrderedListOfObjects
        ](*"Print"*);
      Print["Ordered via Matrix:", OreCurrentMatrix
        ];
      );
(*
Die folgende Funktion ist praktisch, um die aktuelle Ordnung festzuhalten. 
Ihre Ausgabe kann direkt als Eingabe f\[UDoubleDot]r OreRedefineOrder \
verwendet werden, 
OreGetMonomOrder kapselt das Ergebnis in eine Liste.
*)
OreOrderData[] :=
    Sequence[
      OreOrderedListOfObjects,
      OreCurrentMatrix ];

OreGetMonomOrder[] := {OreOrderData[]};
(*
Funktionen zum Modifizieren der Bestehenden Algebrastruktur.
*)
(*
 Neue Objekte einf\[UDoubleDot]hren.
*)
(*
Den internen Zustand den aktuellen Objektlisten anpassen
*)
(*
Die Buchhaltung auf den neuen Stand Bringen, die Ordnung wieder anpassen, \
Remembereffekte r\[UDoubleDot]ckg\[ADoubleDot]ngig machen.
*)
UpdateCounter := 
    Module[{},
      OreNumberOfOperators = Length[OreOperators];
      OreListOfOrderObjects = Flatten[{OreOperators, OreVariables}];
      OreDefineLexOrder;
      Clear[OreExp2Vec];
      MakeOreExp2Vec;
      Clear[MonomToVector];
      MakeMonomToVector
      ];
(*
Hilfsfunktion: Test, ob eine Variable schon belegt ist, oder ein zul\
\[ADoubleDot]ssiges Symbol. 
HoldAll sorgt daf\[UDoubleDot]r, da\[SZ] die Argumente nicht schon beim \
Aufruf ausgewertet werden,
falls das m\[ODoubleDot]glich ist.
*)
SetAttributes[SymbolicQuest, {HoldAll, Listable}];
SymbolicQuest[v_] := ! ValueQ[v];
(*
 Neue Variablen einfuehren. 
*)
Clear[OreDeclareVariables];
SetAttributes[OreDeclareVariables, HoldAll];
OreDeclareVariables::"NonSymbolic" = "There are non symbolic arguments.";

OreDeclareVariables[L_List] :=
    Module[{NewVars},
      If[! And @@ SymbolicQuest[L], (*" any non-symbolic Variables? "*)
      
          Message[OreDeclareVariables::"NonSymbolic"];
        ];
      If[ OreNumberOfVariables > 0, (*" We have already Variables ? "*)
      
          NewVars = Complement[L, OreVariables];  (*" really new Variables. "*)

                OreVariables = Join[OreVariables, NewVars]; (*" Append them all. "*)

                OreNumberOfVariables = 
          Length[OreVariables]; (*" update Number. "*)
        ,(*" Else: We have no Variables declared jet. "*)

                OreVariables = L;
        OreNumberOfVariables = Length[L];
        ];
      OreListOfOrderObjects = Flatten[{OreOperators, OreVariables}];
      UpdateCounter;
      ];

(*
Neue Operatoren einf\[UDoubleDot]hren
*)
(*
Hilfsfunktionen um nichttriviale Substitutionen aus einer Liste von \
Substitutionsregeln herauszufinden.
*)
FindNonZeroRules[r_List] := Select[r, #[[2]] =!= 0 &];
FindNonIdentRules[r_List] := Select[r, #[[2]] =!= #[[1]] &];
(*
Den variablen Teil eines Polynomes bzgl. der geg. Variablenliste finden: es \
wird einfach der Konstante Part abgezogen.
*)
VariablePart[P_, variables_List] := P - (P /. Thread[variables -> 0]);
(*
Allgemeinen Operator anf\[UDoubleDot]gen.
*)
(*
 Neue Operatoren einf\[UDoubleDot]hren und die interne Struktur konsistent \
halten.
Im ersten Schritt werden Namenssymbol und Operation in die \
zuge\[ODoubleDot]rigen Listen eingetragen.
Mittels OreDeclareVariables werden dann die in den Sigma- und Deltalisten \
auftauchenden neuen 
Variablen aufgenommen.
Der in Form von Rules \[UDoubleDot]bergebne Algebrahomomorphismus Sigma wird \
als reine Funktion in
die Liste der Sigmas eingetragen.
Anschlie\[SZ]end wird die Sigma-Derivation Delta nach theoretischen \
\[CapitalUDoubleDot]berlegungen aus der 
Arbeit aus dem gegebnene Sigma aufgebaut und ebenfalls als reine Funktion \
abgespeichert.

*)
OreDefineOperator[Name_Symbol, SigmaX_List, DeltaX_List, Op_Function] :=
    
    Module[{Y, n, fDelt, dVars, fSig},
      OreNumberOfOperators = OreNumberOfOperators + 1;
      With[{n = OreNumberOfOperators},
        OreOperatorNames[n] = Name; 
        Operation[n] = Op; 
        OreDeclareVariables[
          
          Evaluate[
            Union[Flatten[{First[#] & /@ SigmaX, First[#] & /@ DeltaX}]]]
          ];
        fSig = FindNonIdentRules[SigmaX];
        Sigma[
            n] = # /. fSig &; (*" Algebrahomomorphisus anwenden "*)
        
        (*" Delta kann nur die Null- eine Kombination partieller;
            Ableitungen fuer \[Sigma] = id , oder eine innere \[Sigma]-Derivation ;
            fuer \[Sigma] != id sein : "*)
        
        fDelt = FindNonZeroRules[DeltaX];
        If[fDelt === {}, (*" Nullderivation. "*)
          Delta[n] = 0 &   ;
          
          OreOperators = 
            Append[OreOperators, 
              OrePolynomial[OreSummand[1, OreMonomial[{n, 1}]]]]; 
          UpdateCounter;
          Return[OreOperators[[OreNumberOfOperators]] ]
          ];
        If[
          fSig === {},     (*" Kombination vielfacher "klassischer" Derivationen, \[Sigma]=id "*)
\
          (*" Regeln fuer Partielle Ableitungen aus den Substitutionen bestimmen.  "*)

                    dVars = Map[First[#] &, fDelt];                 (*" fuer Delta relevante Variablen.   "*)

                    
          Delta[n] = 
            Function[{P},                         (*" Summe der partiellen Ableitungen. "*)

                            
              Plus @@                                    (*" Ueber die EinzelAbleitungen aufsummieren ... "*)

                                
                Map[                               (*" Jede Substitution aus fDelt einzeln anwenden ... "*)
\
                  #[[2]]D[P, First[#]] &,
                  
                  fDelt                                                       \
           (*" Fuer jede der Regeln. "*)
                  ]
              ]; (*" Function "*)
          ];
        
        If[(fDelt =!= {}) && (fSig =!= {}), (*" Es liegt eine innere Derivation vor! "*)

                    Y[n] = Together[
              (fSig[[1]][[1]] /. 
                    fDelt )/ (*" Erstes X mit \[Sigma](X)!=X waehlen! "*)
    \
            (fSig[[1]][[1]] - 
                    fSig[[1]][[2]])  (*" Vorfaktor Y[n]=\[Delta](X) / (X-\[Sigma](X)) "*)
\
              ];
          
          Delta[n] = 
            Together[
                Y[n]  (# - 
                      Sigma[n][#])] &; (*" Innere \[Sigma]-Derivation "*)
    \
      ];
        (*" Operator verpacken und in die Liste einreihen. "*)
        
        OreOperators = 
          Append[OreOperators, 
            OrePolynomial[OreSummand[1, OreMonomial[{n, 1}]]]];
        UpdateCounter;
        OreOperators[[OreNumberOfOperators]]  (*" neuen Operator zur\[UDoubleDot]ck "*)
\
        ] (*" With n = ..."*)
      ]; (*" Define Ore Operator "*)
(*
Spezielle Operatoren:
*)
(*
Der Shift-Operator.
Hier kann OperatorPowerTimesSummand, also p-faches Shiften um 1 effizient als \
eine einzige Substitution realisiert werden.
*)
OreDefineShift[opname_Symbol, varname_Symbol] :=
    Module[{Res},
      Res = 
        OreDefineOperator[
          opname, {varname -> varname + 1}, {varname -> 
              0}, # /. {varname -> varname + 1} &];
      OperatorPowerTimesSummand[{Res[[1, 2, 1, 1]], p_}, m_] :=
        (
          OperatorPowerTimesSummand[{Res[[1, 2, 1, 1]], p}, m] =
            {{First[m] /. {varname -> varname + p}, 
                OreMonomial[{Res[[1, 2, 1, 1]], p}, m[[2]]]}}
          ); 
      Res
      ];
(*
Der Differentialoperator. Auch hier wird OperatorPowerTimesSummand extra \
definiert.
*)
OreDefineDiff[opname_Symbol, varname_Symbol] :=
    Module[{Res},
      Res = 
        OreDefineOperator[opname, {varname -> varname}, {varname -> 1}, 
          D[#, varname] &];  
      OperatorPowerTimesSummand[{Res[[1, 2, 1, 1]], p_}, m_] :=
        (
          OperatorPowerTimesSummand[{Res[[1, 2, 1, 1]], p}, m] =
            Module[{Rlist, \[Phi] = m[[1]], i},
              Prepend[
                Table[
                  { \[Phi] = D[\[Phi], varname]; Binomial[p, i]\[Phi], 
                    OreMonomial[{Res[[1, 2, 1, 1]], p - i}, m[[2]]]}, {i, 1, 
                    p}
                  ],
                {m[[1]], OreMonomial[{Res[[1, 2, 1, 1]], p}, m[[2]]]}
                ]
              ]
          );
      Res
];
(*
Die q-Differentiation. 
*)
OreDefineQDifferentiation[opname_Symbol, varname_Symbol, qname_Symbol] :=
    
    OreDefineOperator[opname, {varname -> qname varname}, {varname -> 1}, 
      Together[((# /. {varname -> qname varname}) - #)/((qname - 
                    1)varname)] &  ];
(*
Der Dummy-Operator ist ein Kommutativer Operator, der keine Variable beeinflu\
\[SZ]t.
*)
OreDefineDummy[opname_Symbol] := 
    OreDefineOperator[opname, {}, {}, # opname &];
(*
Die Grundoperationen.
*)
(*
EpandedCollect ist eine Hilfsfunktion, die in einem Ausdruck die Monome in \
Ore-Variablen isoliert und optional eine Funktion auf den Koeffizienten ausf\
\[UDoubleDot]hrt. 
(Thanks to Carl Woll, Physics Dept, U of Washington )
*)
ExpandedCollect[expr_, vars_, h_:Identity] := 
    Module[{sub}, Expand[Collect[expr, vars, sub]] /. sub -> h];
(*
Grundlegende Vereinfachungen und Abk\[UDoubleDot]rzungen.
*)
OPo[x_OrePolynomial] := x;
OPo[x_OreSummand] := OrePolynomial[x];
OPo[x_OreMonomial] := OrePolynomial[OreSummand[1, x]];
OPo[x_ /; OreVarMonomialQ[x]] := 
    OrePolynomial[OreSummand[x, OreOneMonomial]];
OPo[x_] := OPo /@ (ExpandedCollect[x, OreVariables]);
OMu[x___] := OreMultiplication[x];
OMu[a_, b_, c__] := OMu[a, OMu[b, c]]; 
OreTerm[x___] := OMu @@ (OPo /@ {x});
(*
Operationen zum Umgang mit den Monomen in den Ore Variablen 
*)
(*
Wandeln von OrePolynomen in ihre Exponentenvektoren und zur\[UDoubleDot]ck.
*)
(*
Einen Ausdruck In eine Linearkombination von Monomen in den OreVariablen \
expandieren.
*)
OreVarExpand[f_] := ExpandedCollect[f, OreVariables];
(*
Testen, ob mit dem gegebnen Ausdruck ein Monom in Ore-Variablen vorliegt. 
Also ein in den Ore Variablen homogenes,  summenfreies Polynom.
*)
OreVarMonomialQ[a_] :=
    
    PolynomialQ[a, 
        OreVariables] &&    (*" must be Polynomial and "*)
      (FreeQ[a, 
            x_ /; MemberQ[OreVariables, x]] || 
          Head[OreVarExpand[a]] =!= Plus); 
(*
Test, ob im Argument Ore-Objekte vorkommen. Nie gebraucht, auskommentiert!
*)
(*"OreHasNoOperators[P_]:=((Head[P]=!=OrePolynomial)||(P[[1,2]]===OreOneMonomial));"*)\

(*
Ein Monom wandeln in eine (Gem\[ADoubleDot]\[SZ] Auftauchens in \
"OreVariables") geordnete Liste L der Exponenten.
R\[UDoubleDot]ckgabe des Faktors und der Liste.  R\[UDoubleDot]ckagabe von \
a,L.
*)
OreExtendedExp2Vec[f_ /; OreVarMonomialQ[f]] :=
    Module[{L, a},
      a = f /. Thread[OreVariables -> 1]; (*" None-Ore-Factor "*)
      
      L = Rest[FactorList[f]]; (*" Factors not equal 1 "*) 
      L = Join[Map[#[[1]] -> #[[2]] &, L], Map[# -> 0 &, OreVariables]]; (*" Make x->i from{x,i}."*)

            L = OreVariables /. L; (*" Substitute Vars in List by Exponents. "*)

            Return[{a, L}];
      ];
(*
 Wegen Remembereffekten mu\[SZ] OreExp2Vec \[ODoubleDot]fter neudefiniert \
werden. 
*)
MakeOreExp2Vec := (
      OreExp2Vec[f_ /; OreVarMonomialQ[f]] :=
          (OreExp2Vec[f] =
              OreExtendedExp2Vec[f][[2]]
            );
      );
MakeOreExp2Vec;
(*" OreVec2OPo[v_] Wandelt die Vektordarstellung in ein Monom zurueck. "*)
(*
OreVec2Mon: R\[UDoubleDot]ckumwandlung eines Vektors in das \
zugeh\[ODoubleDot]rige Monom. Rememberprogrammierung ist vorerst \
auskommentiert.
*)
OreVec2Mon[v_] :=
    ((*" OreVec2Mon[v]= "*)
      
      OreMonomial @@ 
        Transpose[{Table[i, {i, OreNumberOfOperators}], 
            Take[v, OreNumberOfOperators]}]
      );
OreVec2OPo[v_] :=
    ((*" OreVec2OPo[v]= "*)
      OrePolynomial[
        OreSummand[
          Times @@ (OreVariables^Take[v, -OreNumberOfVariables]),
          
          OreMonomial @@ 
            Transpose[{Table[i, {i, OreNumberOfOperators}], 
                Take[v, OreNumberOfOperators]}]
          ]
        ]
      );
MakeMonomToVector := (
      MonomToVector[OreOneMonomial] := Table[0, {OreNumberOfOperators}];
      MonomToVector[m_OreMonomial] := (
          MonomToVector[m] =
            Module[{T},
              T = Table[0, {i, 1, OreNumberOfOperators}];
              For[i = 1, i <= Length[m], i++,
                 T[[ m[[i, 1]] ]] = m[[i, 2]] ;
                ];
              T
              ])
      );
MakeMonomToVector;
SummandToVector[f_OreSummand] := 
    Join[
      MonomToVector[f[[2]]]
      ,
      OreExp2Vec[f[[1]]] ];
OrePolynomialToVector[OrePolynomial[f_]] :=
    SummandToVector[f];
(*
Operationen in direktem Zusammenhang mit Ordnungen
*)
(*
Ordnung auf Zahlenvektoren.
*)
(*
 Lexikographisch 
*)
VectorLessLex[a_List, b_List] := ! OrderedQ[{b, a}];
(*
 umgekehrt Lexikographisch 
*)
VectorLessInvLex[a_List, b_List] :=
    ! OrderedQ[{Reverse[b], Reverse[a]}];
(*
 Grad - Lexikographisch 
*)
VectorLessDegLex[a_List, b_List] :=
    
    Module[{A = Plus @@ a, B = Plus @@ b},
      A < B || ((A === B) &&  VectorLessLex[a, b])
      ];
(*
 Grad - umgekehrt Lexikographisch 
*)
VectorLessDegInvLex[a_List, b_List] :=
    
    Module[{A = Plus @@ a, B = Plus @@ b},
      A < B || ((A === B) &&  VectorLessInvLex[a, b])
      ];
(*
Beliebige Matrixordnung. 
*)
VectorLessMatrix[a_List, b_List, M /; MatrixQ[M]] :=
    
    VectorLessLex[a.M, b.M];
(*
Ordnung auf Ore-Summanden. 
*)
(*
Tests, ob ein Monom vorliegt, ob dieses monisch ist.
*)
OreIsSummandQ[P_OrePolynomial] := (Length[P] == 1);
OreIsMonicQ[P_OrePolynomial] := 
    OreIsSummandQ[P] && OreExtendedExp2Vec[P[[1, 1]]][[1]] === 1;
(*
Im folgenden werden spezielle Ordnungen \[UDoubleDot]ber Matrixordnungen \
realisiert. Eigentlich sollten doch die speziellen
Varianten ausgenutzt werden ?!
*)
(*" Lexikografische Ordnung "*)
OreDefineLexOrder := (OreRedefineMonomOrder[OreListOfOrderObjects, 
        IdentityMatrix[OreNumberOfObjects]]);

(*" Default: Lexikografisch "*)
OreDefineLexOrder;

(*" "Inverse" Lexikografische Ordnung "*)

OreDefineReverseLexOrder :=
    
    OreRedefineMonomOrder[OreListOfOrderObjects, 
      Reverse[IdentityMatrix[OreNumberOfObjects]]];

(*" ---> "*)
OreDefineDegLexOrder :=
    
    OreRedefineMonomOrder[OreListOfOrderObjects,
      Prepend[
        Rest[IdentityMatrix[OreNumberOfObjects]],
        Table[1, {OreNumberOfObjects}]
        ]
      ];

OreDefineReverseDegLexOrder :=
    
    OreRedefineMonomOrder[OreListOfOrderObjects,
      Prepend[
        Reverse[1 - Rest[IdentityMatrix[OreNumberOfObjects]]
          ],
        Table[1, {OreNumberOfObjects}]
        ]
      ];
(*
Ordnung auf OreSummanden und OrePolynomen definieren:
*)
(*
Dabei bedeutet "/:", da\[SZ] nicht "<" (Less) umdefiniert wird, sondern die \
Definition an
"OreSummand" gebunden ist.
*)
OreSummand /: OreZeroSummand < OreZeroSummand := False;
OreSummand /: OreZeroSummand < _OreSummand := True;
OreSummand /: a_OreSummand < b_OreSummand := 
    VectorLess[SummandToVector[a], SummandToVector[b]];

OrePolynomial /: a_OrePolynomial < b_OrePolynomial :=
    
    First[OreSimplify[a]] < First[OreSimplify[b]];
(*
Umdefinieren der Ordnung auf den Multiindizees 
*)
(*
Hilfsfunktion: Eine Matrix oben links in eine Einheitsmatrix einschreiben. 
*)
RenderMatrix[A0_, Lgt_Integer] :=
    Module[{A = A0, i},
        m = Length[A[[1]]];
        A = 
          Map[Join[#, Table[0, {Lgt - m}]] &, 
            A];                              (*" rechts um Nullen ausbauen "*)

                A = Join[A, Table[Table[0, {Lgt}], {Lgt - Length[A]}]]; (*" nach unten ausbauen "*)

                For[i = m + 1, i <= Lgt , 
          i++,                                                                \
(*" Diagonale mit Einsen auffuellen. "*)
          
          A = ReplacePart[ A, 1, {i, i}]; 
          ];
        A
        ] /; Length[A0[[1]]] <= Lgt;
(*
Liegt eine einzelne Unbestimmte vor?
*)
SimpleObjectQ[P_OrePolynomial] := Module[{v},
      If[! OreIsMonicQ[P], Return[False]];
      v = SummandToVector[P];
      Return [
        1 === Plus @@ (If[# =!= 0, 1, 0] & /@ 
                v)]; (*" genau ein Objekt vorhanden"*)
      ];
(*
Umdefinieren der aktuellen Monomordnung: 
Zu den \[UDoubleDot]bergebenen Monomen in ihrer Reihenfolge wird die \
\[UDoubleDot]bergebene Matrixordnung zu einer Matrixordnung
ausgebaut. 
Dazu wird die entsprechende Matrix f\[UDoubleDot]r die interne Ordnung \
berechnet. 
*)
OreRedefineMonomOrder[Monomials_List, M_List] :=
    
    Catch[Module[{Perm, A, Dummy},
          
          If[ (*" Liegen wirklich Monome vor? "*)
            
            Apply[And, Map[SimpleObjectQ[#] &, Monomials]] || (*" All simple Objects? "*)

                            Length[Monomials] =!= Length[Union[Monomials]], (*" not pairwise different? "*)

                        
            Throw["given Polynomials can't be used to define an order."]
            ];
          If[Not[MatrixQ[M]],
            
            Throw["The second argument of OreRedefineMonomOrder should be a matrix."]\

            ];
          If[Dimensions[M] =!= {Length[Monomials], Length[Monomials]},
            Throw["The matrix is not of the correct form."]
            ];
          If[Det[M] == 0,
            Throw["The order matrix is singular."]
            ];
          
          (*" Die geg. Monome in eine Liste der Indizees der internen Reihenfolge uebersetzen. Anbei Gueltigkeit checken. "*)

                    v = Table[
              
              If[Head[Monomials[[i]]] =!= OrePolynomial, (*" Variable? "*)
   
                             If[
                  MemberQ[OreVariables, Monomials[[i]]], (*" registrierte Variable? "*)

                                    
                  OreNumberOfOperators + 
                    Plus @@ Flatten @@ Position[OreVariables, Monomials[[i]]]
                  , (*" else "*)
                  
                  Throw["Objects not valid"];
                  ]
                , (*" else: Operator "*)
                
                Monomials[[i, 1, 2, 1, 
                    1]] (*" internal Number of that Operator"*)
              \
  ],
              {i, 1, Length[Monomials]}
              ];
          
          With[{ n = OreNumberOfObjects},
            v = Join[v, Complement[Table[i, {i, n}], v]]; (*" Ergaenzen zur Gesammtobjektanzahl. "*)

                        OreOrderVector = v;
            
            Perm = Table[Position[v, i][[1, 1]], {i, n}]; (*" Umkehrpermutation bestimmen "*)

                        OreInternalToActual = Perm;
            AA = RenderMatrix[M, n];
            
            (*" A wird Durch Spaltenumordnung an die reale interne Anordnung unserer Monome angepasst. "*)
\
            
            A = Transpose[Table[Transpose[AA][[Perm[[i]]]], {i, 1, n}]];
            
            ]; (*" With n = OreNumberOfOperators "*)
          
          (*" Umdefinieren der Monomordnung "*)
          
          VectorLess[a_List, b_List] := ! OrderedQ[{A.b, A.a}];
          OreCurrentMatrix = AA;
          OreOrderVector = v; (*" Kanonische Ordnung "*)
          ];
      ]; (*" Catch "*)
(*
Operationen und Regeln f\[UDoubleDot]r Monome in den Ore Operatoren.
*)
(*
Mehrfach auftretende Operatoren werden zusammengefasst:
*)
OreMonomial[{a_, x_}, {a_, y_}] := OreMonomial[{a, x + y}];
(*
Faktoren mit Exponent Null verschwinden:
*)
OreMonomial[{_, 0}] := OreMonomial[];
(*
Eine Funktion auf alle Koeffizienten der Operatormonome anwenden:
*)
OreMapOnCoefficients[f_Function, P_OrePolynomial] :=
    
    Map[OreSummand[f[#[[1]]], #[[2]]] &, P];
(*
Leitkoeffizient, Leitoperatoren, Leitterm und Leitmonom:
*)
OreLeadingCoefficient[f_OrePolynomial] :=
    
    f[[1, 1]] /. (# -> 1 & /@ OreVariables); 
OreLeadingOperatorMonomial[f_OrePolynomial] :=
    OreSimplify[f][[1, 2]];
OreLeadingSummand[f_OrePolynomial] :=
    OreSimplify[f][[1]];

OreLeadingMonomial[f_OrePolynomial] :=
    Block[{t = OreLeadingSummand[f]},
      OreSummand[
        First[t]/(First[t] /. (# -> 1 & /@ OreVariables)),
        t[[2]]
        ]
      ];
(*
Terme niedrigerer Ordnung als der Leitterm:
*)
OreLesserTerms[p_OrePolynomial] :=
    If[Length[p] > 1,
      Rest[OreSimplify[p]]
      ,(*" else "*)
      OreZero
      ];
OreCoefficientList[P_OrePolynomial] :=
    
    Table[P[[i, 1]], {i, 1, Length[P]}] /. {Sequence @@ 
          Thread[OreVariables -> 1]};
(*
Der Inhalt als GCD der Koeffizienten. Verbesserung: PolynomialGCD der \
Koeffizientenliste?
*)
OreContent[P_OrePolynomial] := PolynomialGCD @@ OreCoefficientList[P];
(*
Variableninhalt: maximalen Linksfaktor als Polynom in den Ore Variablen \
finden:
*)
OreVarContent[P_OrePolynomial] :=
    Module[{tmp},
      tmp = Sort[List @@ P, Order[#1[[2]], #2[[2]]] == 1 &];
      tmp = Split[tmp, #1[[2]] == #2[[2]] &];
      tmp = (Plus @@ (First /@ #) &) /@ tmp;
      PolynomialGCD @@ tmp
      ];
(*
 Inhalt herausdividieren.                                     
*)
OreEliminateContent[P_OrePolynomial] :=
    
    OreMapOnCoefficients[Together[#/OreContent[P]] &, P];
(*
Variableninhalt herausk\[UDoubleDot]rzen:
*)
(*
 - Sortieren & Zusammenfassen nach Operatoren.
- Aufaddieren der zugeh\[ODoubleDot]rigen Variablen.
- Bilden des Polynom-GCD, herausdividieren. 
- neue Variablen mit den gemerkten Operatoren zusammenf\[UDoubleDot]gen. 
*)
OreVarEliminateContent[P_OrePolynomial] :=
    Module[{tmp, ops, gc},
      tmp = Sort[List @@ P, Order[#1[[2]], #2[[2]]] == 1 &];
      tmp = Split[tmp, #1[[2]] == #2[[2]] &];
      ops = Last /@ First /@ tmp;
      tmp = (Plus @@ (First /@ #) &) /@ tmp;
      gc = PolynomialGCD @@ tmp;
      tmp = Together[#/gc] & /@ tmp;
      Inner[OMu[OPo[#1], OPo[#2]] &, tmp, ops, Plus]
      ];
(*
 Abfragen, ob eine Einheit vorliegt:
*)
OreIsUnitQ[
      P_OrePolynomial] :=
    (OreLeadingOperatorMonomial[P] === 
          OreOneMonomial) && (Variables[
            OreLeadingCoefficient[P]] === {}) &&  (OreLeadingCoefficient[P] !=
           0);
(*
Einheit invertieren:
*)
OreInverse[P_OrePolynomial /; OreIsUnitQ[P]] :=
    
    OPo[(OreLeadingCoefficient[P])^(-1)];
(*
Abfrage, ob ein OrePolynom nur aus einem Grundobjekt besteht:
*)
OreIsObjectQ[M_] := 
    (Head[M] === OrePolynomial) && (Length[M] == 1) &&
      (1 === 
          Plus @@ Abs /@ SummandToVector[First[M]]);
(*
 Bestimmen des Exponenten eines Objektes in einem Summanden:
*)
OreExponent[M_OrePolynomial /; OreIsObjectQ[M], S_OreSummand] := 
    Plus @@
      (SummandToVector[S]*SummandToVector[First[M]]);
(*
Exponent eines Objektes in einem Polynom:
*)
OreExponent[M_OrePolynomial /; OreIsObjectQ[M], S_OrePolynomial] := 
    Max[OreExponent[M, #] & /@ (List @@ S)];
(*
 Addition
*)
(*
Das zentrale Werkzeug ist OreSimplify, da\[SZ] Ore Polynome stets in eine \
Darstellung als geordnete Sume von Termen darstellt.  
*)
(*
OreSimplify: Liste von Ore Summanden aufaddieren und  vereinfachen. 
*)
(*
Einige triviale Regeln:
*)
OreSimplify[{}] := {OreZeroSummand};
OreSimplify[{OreSummand[0, _OreMonomial]}] := {OreZeroSummand}; (*" Term mit Faktor 0 entfernen. "*)

OreSimplify[{f_OreSummand}] := {f}; 
(*
Vereinfachen einer Liste von Summanden. 
1. Aufsteigend nach der Monomordnung sortieren.
2. "Runs" gleicher Monome mittels "Split" gruppieren, und anschlie\[SZ]end \
die Koeffizienten aufaddieren.
3. Nullen Eliminieren und falls nichts \[UDoubleDot]brig bleibt, \
OreZeroSummand zur\[UDoubleDot]ckgeben.
*)
OreSimplify[f_List] :=  Module[{n, sumliste, runliste, zsumm, Result},
        sumliste = Sort[f, #2 < #1 &];  
        runliste = 
          Split[sumliste, SummandToVector[#1] === SummandToVector[#2] &];
        Result = 
          OreSummand[Together[Plus @@ Map[#[[1]] &, #]], #[[1, 2]]] & /@ 
            runliste; 
        
        Result = Select[Flatten[Result], First[#] =!= 0 & ]; 
        If[Result =!= {}, Result, {OreZeroSummand} ] 
        ] /; f =!= {} (*" Module "*);
(*
Ein OrePolynom vereinfachen bedeutet nun einfach die Liste der Summanden zu \
vereinfachen.
*)
OreSimplify[OrePolynomial[f__]] :=
    
    OreSimplifyCoefficients[Apply[OrePolynomial, OreSimplify[{f}]]];
(*
Die Koeffizientenpolynome vereinfachen: 
*)
OreSimplifyCoefficients[f_OrePolynomial] :=
    
    OreMapOnCoefficients[Collect[#, OreVariables] &, f];
(*
Summanden zu einem OrePolynomen aufaddieren ist nun eine Anwendung von \
Simplify:
*)
OreSummand /: Plus[f__OreSummand] :=  
    Apply[OrePolynomial, OreSimplify[{f}]];
(*
Damit erhalten wir schon die Addition von Ore Polynomen (die ja als Listen \
ihrer Summanden definiert sind):
*)
Plus[OrePolynomial[f__OreSummand], OrePolynomial[g__OreSummand]] ^:= 
    Plus[f, g];
(*
Multiplikation
*)
(*
Die gew\[ODoubleDot]hnliche Multiplikation wird nur f\[UDoubleDot]r \
linksmultiplikation mit expliziten Zahlen zugelassen.
*)
Times[a_OrePolynomial, b_OrePolynomial]  ^:= 
    Return["Times doesn't work on Ore-Objekts !"];
Times[a_OreSummand, b_OrePolynomial]  ^:= 
    Return["Times doesn't work on Ore-Objekts !"];
Times[a_, b_OrePolynomial] ^:= OreMultiplication[OPo[a], b] /; NumberQ[a];
(*
Hilfsfunktion: In einer Liste von OreSummanden gleiche Operatorpotenzen \
zusammenfassen: 
f\[UDoubleDot]r jeden "Run" gleicher Operatorpotenzen die Variablen \
aufaddieren.
*)
CollectSame[L_] :=
    {Plus @@ (#[[1]] & /@ #), #[[1, 2]]} & /@ 
      Split[
        Sort[L, OrderedQ[{#1[[2]], #2[[2]]}] &],
        #1[[2]] == #2[[2]] &];
(*
F\[UDoubleDot]r ein OrePolynomial p die Darstellung in der Gestalt 
\!\(TraditionalForm\`\(p\_1\) d\_1\^\[Alpha]\_1 + \[Ellipsis] + \(p\_k\) d\_k\^\[Alpha]\_k\)mit Polynomen \!\(TraditionalForm\`p\_i\)und verschiedenen Operatorpotenzen \!\(TraditionalForm\`d\_i\^\[Alpha]\_i\)
in Form einer Liste zur\[UDoubleDot]ckgeben.
*)
CollectOperators[p_] :=
    CollectSame[List @@ p];
(*
Ein Monom von links mit einer Operatorpotenz multiplizieren.
*)
(*
Dies ist die generische Variante, einen Summanden mit der j-ten Potenz des \
Operators i zu multiplizieren.
Das erste Argument hat also die Gestalt op={i,j}, das Zweite ist als \
OreSummand ein Term \!\(TraditionalForm\`m = \(m\_var\) m_op\). 
Startend mit dem Polynomanteil des Summanden werden f\[UDoubleDot]r jede \
Operatorpotenz 0, \[Ellipsis], k, \[Ellipsis], j die Koeffizienten \!\(TraditionalForm\`c\_i\)in 
\!\(TraditionalForm\`m = \(\(D\^\(j - k\)\)(c\_0 + \(c\_1\) D + \(c\_2\) D\^2 + \(\[Ellipsis]c\_k\) D\^k)\) m\_op\)als Liste bestimmt.
Anschlie\[SZ]end werden die Operatorvariablen um \!\(TraditionalForm\`m\_var\)aufgef\[UDoubleDot]llt. Ein Select entfernt Nullterme.

F\[UDoubleDot]r spezielle Operatoren sollte nach M\[ODoubleDot]glichkeit eine \
Schnellere Variante bereitgestellt werden,
da diese Operation zeitkritisch und Grundlegend f\[UDoubleDot]r weitere \
Berechnungen ist.
*)
OperatorPowerTimesSummand[op_, m_] :=
    Module[{PoLis ,
        DegCount = Last[op] 
        },
      PoLis = {First[m]}; 
      With[{i = First[op]},(*" i ist the Number of the Operator. "*)
        
        While[DegCount > 0,
          PoLis = Prepend[Map[Sigma[i], PoLis], 0] +
              Append[Map[Delta[i], PoLis], 0];
          DegCount--;
          ];
        Select[ 
          
          Table[{PoLis[[k + 1]], OreMonomial[m[[2]], {i, k}]}, {k, 0, 
              op[[2]]}]
          , First[#] =!= 0 &
          ]
        ] (*" With i=op[[1]] "*)
      ];
(*
Die selbe Operation f\[UDoubleDot]r eine Liste aufzusummierender Summanden:
*)
OperatorPowerTimesSummandList[op_, L_] :=
    CollectSame[
      Flatten[OperatorPowerTimesSummand[op, #] & /@ L, 1]
      ];
(*
Nacheinander die OperatorPotenzen des Monomes multiplizieren (ein Monom ist \
einfach als
eine Liste von Operatorpotenzen realisiert):
*)
OperatorMonomTimesSummandList[m_, L_] :=
    
    Fold[OperatorPowerTimesSummandList[#2, #1] &, L, m];
(*
Nun k\[ODoubleDot]nnen einen Summanden mit einer Liste von Summanden \
multiplizieren:
*)
SummandTimesSummandList[s_, L_] :=
    {First[s]*First[#], #[[2]]} & /@ 
      OperatorMonomTimesSummandList[s[[2]], L];
ListMult[L_, M_] :=
    CollectSame[
      Flatten[SummandTimesSummandList[#, M] & /@ L, 1]
      ];
(*" Aus einem Ausdruck in Variablen eine Liste von Summanden machen: "*)
(*" Variation von ExpandedCollect, um ein Polynom in eine Liste
  von OreSummanden zu \[UDoubleDot]berf\[UDoubleDot]hren: "*)
(*
Hilfsfunktion: MakeSummandList aus einem (evtl. inhomogenen) Polynom eine \
Liste von 
Objekten vom Typ OreSummand machen. In gewissem Sinne die Umkehrung von 
"CollectSame". Der gr\[ODoubleDot]\[SZ]te Aufwand ist hierbei das Verhindern \
von vorzeitigem Anwenden
der Regeln, die mit den Funktionen OreMonomial und OreSummand verbunden sind.
*)
MakeSummandList[{expr_, mon_}] :=
    Module[{sub, osu, Zwi},
      Zwi = ((Expand[Collect[expr, OreVariables, sub]]
                  /. {Times[a_, sub[b_]] -> osu[a b, mon]})
              /. {sub[a_] -> osu[a, mon]})
          /. osu -> OreSummand ;(*" nicht zu frueh, sonst rechnet OreSummand ..."*)

            If[Head[Zwi] === OreSummand, {Zwi}, List @@ Zwi]
      ];
(*
Ore Multiplikation
*)
(*
Nach diesen Vorbereitungen ist f\[UDoubleDot]r die Multiplikation von Ore \
Polynomen nicht mehr viel zu tun:
Die einstellige Multiplikation operiert trivial, mehrstellige \
\[UDoubleDot]ber die implementierte Listenoperation,
der Bequemlichkeit wird noch die linksmultiplikation mit einer rationalen \
Zahl definiert.
*)
OreMultiplication[v_OrePolynomial] := v;
OreMultiplication[v_OrePolynomial, w_OrePolynomial] :=
    
    Module[{L1, L2, Res},
      L1 = CollectOperators[v]; L2 = CollectOperators[w];
      Res = Flatten[MakeSummandList /@ ListMult[L1, L2]];
      OPo[Plus @@ Res]
      ];
OreMultiplication[v_ /; Element[v, Rationals], w_OrePolynomial] :=
    
    OreMultiplication[OPo[v], w];
(*
 Schnelles Potenzieren:
*)
Power[x_OrePolynomial, n_ /; n > 1] ^:= (
       OrePolynomial /: Power[x, n] =
        OreMultiplication[Power[x, Floor[n/2]], Power[x, n - Floor[n/2]]]
      );
(*
Operatoren Anwenden
*)
OreApply[OreOneMonomial, P_] := P;
OreApply[m_OreMonomial, P_] :=
    OreApply[
      Rest[m], (*" Restliche Operationen aufheben und ... "*)
      
      Nest[ Operation[ m[[1]][[1]] ], P, 
        m[[1]][[2]]] (*" ... erste Op abarbeiten. "*)
      ]; (*" Apply "*)
OreApply[m_OrePolynomial, P_] :=
    
    Apply[Plus, Map[#[[1]]*OreApply[#[[2]], P] &, m]];
(*
H\[ODoubleDot]here Funktionen
*)
(*
Nun kommt noch eine Kollektion von h\[ODoubleDot]eren Funktionen, die vom \
Funktionstyp nicht unbedingt
in das Grundpaket geh\[ODoubleDot]ren, die aber so stark auf die interne \
Struktur zur\[UDoubleDot]ckgreifen, da\[SZ] der 
Abschlu\[SZ] der internen Strukturen eine Bereitstellung erfordert.
*)
(*
"LCM" der Operatormonome - braucht doch wieder keiner!
*)
(*
Berechnen von LCM der Operatormonome, und den 'Fehlstaenden' x,y mit a*x = \
b*y = LCM[a,b] 

*)
(*" OreExtendedSummandLCM[a_OreSummand,b_OreSummand]:=
  Module[{u,v,w},
  u=SummandToVector[a]; v=SummandToVector[b];
  w= Max/@Transpose[{u,v}];
  {OreVec2OPo[w],OreVec2OPo[w-u],OreVec2OPo[w-v]}
  ];"*)
(*
F\[UDoubleDot]r Gr\[ODoubleDot]bnerbasen: Das S-Polynom
*)
(*
Das S-Polynom S von p und q sowie die Darstellung S = ap+bq   werden \
bestimmt.
Erst werden dazu die Operatoranteile va, vb von a resp. b bestimmt.
Dann werden die Leitmonome von va p und vb q betrachtet,  von denen der
Variablenpart A resp B genommen wird. 
Die Variablenanteile von a,b werden dann so gew\[ADoubleDot]hlt, da\[SZ] sich \
genau die Leitmonome
herausheben, wenn man va durch a und vb durch b ersetzt.
Die nicht erweiterte Funktion ist fast der selbe Text, wobei die \
Koeffizienten nicht mehr 
explizit bestimmt werden m\[UDoubleDot]ssen.
*)
OreExtendedSPolynomial[p_OrePolynomial, q_OrePolynomial] :=
    
    Module[{v, w, vg, va, vb, a, b, A, B, AuB},
      v = MonomToVector[p[[1, 2]]];(*" Operatoren von p "*)
      
      w = MonomToVector[q[[1, 2]]];(*" Operatoren von q "*)
      
      vg = Max /@ Transpose@{v, w}; (*" "kommutativer" ggt der Operatoren "*)

            va = OPo[OreVec2Mon[vg - v]]; (*" Operatoren von a "*)
      
      vb = OPo[OreVec2Mon[vg - w]];(*" Operatoren von b "*)
      
      A = First[OreLeadingSummand[OMu[va, OPo[OreLeadingSummand[p]]]]]; (*" resultierender Variablenpart, erster Summand"*)

            B = 
        First[OreLeadingSummand[
            OMu[vb, OPo[OreLeadingSummand[q]]]]];(*" resultierender Variablenpart, zweiter Summand"*)

            AuB = PolynomialGCD[A, B]; (*" gemeinsamer Faktor. "*)
      
      a = OMu[OPo[Cancel[B/AuB]], va]; (*" Koeffizienten bestimmen "*)
      
      b = OMu[OPo[-Cancel[A/AuB]], vb];
      Return[{OMu[a, p] + OMu[b, q], a, b}];
      ];
OreSPoly[p_OrePolynomial, q_OrePolynomial] :=
    
    Module[{v, w, vg, va, vb, A, B, AuB},
      v = MonomToVector[p[[1, 2]]];(*" Operatoren von p "*)
      
      w = MonomToVector[q[[1, 2]]];(*" Operatoren von q "*)
      
      vg = Max /@ Transpose@{v, w}; (*" "kommutativer" kgv der Operatoren "*)

            va = OPo[OreVec2Mon[vg - v]]; (*" Operatoren von a "*)
      
      vb = OPo[OreVec2Mon[vg - w]];(*" Operatoren von b "*)
      
      A = OreLeadingSummand[OMu[va, OPo[OreLeadingSummand[p]]]][[1]];  (*" resultierender Variablenpart, erster Summand"*)

            B = OreLeadingSummand[OMu[vb, OPo[OreLeadingSummand[q]]]][[1]];(*" resultierender Variablenpart, zweiter Summand"*)

            AuB = PolynomialGCD[A, B]; (*" gemeinsamer Faktor. "*)
      
      Return[OMu[OPo[Cancel[B/AuB]], va, p] +
          OMu[OPo[-Cancel[A/AuB]], vb, q]];
      ];
(*
Gr\[ODoubleDot]bnerwalk: Ordnungsspezifische Funktionen:
*)
(*
SolvableQ: Testen der gegebnen Struktur auf "solvable type".
*)
(*
Die Algebra mit der aktuellen Ordnung ist vom Solvable type, wenn f\
\[UDoubleDot]r alle Kombinationen von Operatoren
\!\(TraditionalForm\`D\_i\)und Variablen \!\(TraditionalForm\`X\_j\)gilt: \!\(TraditionalForm\`\(X\_j\) D\_i <= D_i\)X_j: (k\[ODoubleDot]nnte ja auch nach OreAlgorithms)
*)
SolvableQ := Block[{norm, reve,
      Vrs = OPo /@ OreVariables},
    norm = Flatten[Outer[OMu, Vrs, OreOperators]];
    reve = 
      OPo[OreLeadingMonomial[#]] & /@ 
        Flatten[Transpose[Outer[OMu, OreOperators, Vrs]]];
    norm === reve
    ]
(*
Hilfsfunktion, die die Eintr\[ADoubleDot]ge eines Exponentenvektors f\
\[UDoubleDot]r ein Monom von der internen
in die  durch die Aktuelle Reihenfolge der Monome gegebene permutiert:
*)
ActualOrder[x_] := x[[#]] & /@ OreOrderVector;
(*
Hilfsfunktion, die eine Listen normierter Summanden aus einer Liste von Ore \
Polynomen
erstellt: (ist der Normierungskrempel \[UDoubleDot]berhaupt \
n\[ODoubleDot]tig?)
*)
AllSummands[L_List] := (
      (L /. {OrePolynomial -> List, n_Rational -> 1})
        /. {Times[n_Integer, r__] -> Times[r],
          OreSummand[n_Integer, r__] -> OreSummand[1, r]}
      );
(*
Aus einer Liste von Ore Polynomen die Exponentenvektoren aller Terme \
extrahieren:
*)
OrePolynomialsToVectorList[f_List] :=
    
    Map[ActualOrder, Map[SummandToVector, AllSummands[f], {2}], {2}];
(*
 Initialvalue: Das Gewicht eines Summanden bez\[UDoubleDot]glich der \
aktuellen Norm berechnen. Dazu den Ordnungsvektor in die aktuelle Reihenfolge \
permutieren, und mit der ersten Zeile der aktuellen Ordnungsmatrix \
multiplizieren.
*)
OreInitialValue[
      s_OreSummand] :=
    (SummandToVector[s][[#]] & /@ 
          OreOrderVector).OreCurrentMatrix[[1]];
(*
Initialterm: Der erste "Run" der gewicht sortierten Summanden.
*)
OreInitialTerm[x_OrePolynomial] :=
    
    OrePolynomial @@ 
      First[Split[List @@ x, OreInitialValue[#1] == OreInitialValue[#2] &]];
(*
Degenerationspunkt bestimmen.
*)
(*
Hier geht es um die Randbestimmung beim Gr\[ODoubleDot]bnerwalk.
NextDegenerationVec bestimmt den Rand f\[UDoubleDot]r eine Menge von \
Vektoren, 
NextDegeneration f\[UDoubleDot]r eine Menge von Ore Polynomen.
Zur\[UDoubleDot]ckgegeben wird der Wert t\[Element][0,1], an dem in einen \
neuen "cone"
auf dem Pfad  w = a+t(v-a) mit (a = OreCurrentMatrix[[1]])
eingetreten wird. Gibt es kein solches t, so wird t=2 \
zur\[UDoubleDot]ckgegeben.
Idee: F\[UDoubleDot]r alle l_i\[Element]L mit \!\(TraditionalForm\`l\_i != l\_1\)l\[ODoubleDot]sen wir die Gleichung 
\!\(\*FormBox[
  RowBox[{
    RowBox[{
      FormBox[\(l\_1\),
        "TraditionalForm"], ".", \((v + t(v - a))\)}], "==", \(l\_i . \((v + t(v - a))\)\)}], TraditionalForm]\) und geben die kleinste L\[ODoubleDot]sung zur\[UDoubleDot]ck.
*)
 NextDegeneration[L_List, v_List /; Length[L] == 1] := {v, 1}; 
(*
F\[UDoubleDot]r eine Liste von Polynomen werden Ordnungsvektoren aller Terme \
betrachtet:
*)
NextDegeneration[L_List, v_List] :=
    First[Sort[
        NextDegenerationVec[#, v] & /@ OrePolynomialsToVectorList[L],
        #1[[2]] < #2[[2]] &
        ]];
(*
Die Berechnungen finden auf einer Menge von (Exponenten-)Vektoren statt.
*)
NextDegenerationVec[L_List, v_List] :=
    Module[
      {t, tmp, u, vv, Candidate, LL, LLZ, LLN},
      u = OreCurrentMatrix[[1]]; (*" actual top-wight "*)
      
      vv = v - u; (*" Current direction. "*)
      
      tmp = Sort[L, Not[OrderedQ[{#1.u, #2.u}]] &];
      tmp = 
        Split[L, #1.u == #2.u &]; (*" separate initials "*)
      {initials, 
          LL} = {First[tmp], Flatten[Rest[tmp], 1]};
      
      If[LL == {}, Return[{v, 1}]]; (*" no eqations to solve. "*)
      
      Candidate = First[Sort[initials, Not[OrderedQ[{#1.v, #2.v}]] &]];
      LL = # - Candidate & /@ Rest[L]; (*" the differencevectors. "*)
      
      LLZ = LL.u;  (*" enumerators "*)
      LLN = LL.vv; (*" denominators "*)

            LL = Select[Transpose[{LLZ, LLN}], #[[2]] != 0 &]; (*" demum. != 0 "*)

            LL = -#[[1]]/#[[2]] & /@ LL; (*" calculate the quotients. "*)
    
        LL = Select[LL, # > 0 &]; (*" t>0 required. "*)
      t = Min[LL];
      If[(t <= 0) || (t > 1), Return[{v, 2}], (*" no t found! "*)
        
        Return[{OreCurrentMatrix[[1]] + t vv, 
            t}]; (*" found next wight "*)
        ]
      ];

End[];  (*" Private Context "*)
EndPackage[];
