(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











BeginPackage["OreAlgorithms`","Ore`"];





OreAlgebrasVersion::usage="OreAlgebrasVersion returns the package version.";

BaseGenerators::usage="This is an option for extended gr\[ODoubleDot]bnerbase manipulations. The option BaseGenerators->G is needed for functions to check whether the generated coefficients are correct.";

InfoMessage::usage = "InfoMessage[verboselevel_Integer,priority_Integer,__] prints all data after the first two arguments if priority is not less than the verboselevel.";

OreCheckExtended::usage="OreCheckExtended[r_,G_] looks, whether the extended orepolynomial r={p,lp} statisfies the condition that the List lp of OrePolynomials generates r in the form p=lp[[1]]*G[[1]]+...+lp[[g]]*G[[g]], with g = |G|.";

OreDivision::usage="OreDivision[a_OrePolynomial, g_List] performs the division algorithm for dividing a by multiple polynomials. It determines a representation r=a+a1*g1+a2*g2+...+al*gl, where deg r < deg gi for all i. It returns {r, {a1, a2, ... al}} 
";

OreDivisionExtended::usage=
    "OreDivisionExtended[p_,L_List,vl_Integer:0,Options_:{}] performs the Ore(Extended)Division of exteded Polynomials, keeping track of the coefficients and returning as result the extended result, i.e. {r,L} with the result r and a List L of Coefficients presenting r with Respect to a given Base. For higher verbosity levels the reference base G has to be given as option BaseGenerators\[Rule]<Referencebase>";

OreExtendedLeftGroebnerLimited::usage=
    "OreExtendedLeftGroebnerLimited[l_List,LengthLimit_Integer, vl_Integer:0]: Generates a left groebnerbase of l={g1, ..., gn}, where for every element gj of the groebnerbase a list of coefficients lj={c1, .. cn} with g=c1 g1+ ... + cn gn is created. Returns: {{g1,l1},...{gm, lm}}. Of course this is much slower than the pure groebnerbase calculation.";

OreExtendedNormalForm::usage="OreExtendedNormalForm[f_,P_] calculates the normalform of an extended f-polynomial (i.e. a list consisting of an ore polynomial together with the coefficients of the representation with respect of a set of ore polynomials) based on a set P of estended ore polynomials.";

OreExtendedSPoly::usage="OreExtendedSPoly[{p_OrePolynomial,lp_List},{q_OrePolynomial,lq_List}] calculates the S-polynomial of p and q and a representation l from the polynomials p,q and their representations lp and lq.";

OreGCD::usage="OreGCD[a_OrePolynomial, b_OrePolynomial]";

OreIsLeftGroebner::usage="OreIsLeftGroebner[l_List,vl_Integer:0]: Test whether the list l is a groebnerbase (looks whether every S-polynom reduces to zero). If vl>0 occures, entering the procedure is mentioned.";

OreLeftGroebner::usage = "OreLeftGroebner[l_List, verboselevel_Integer:0] finds for a given list of Ore-polynomials a left groebnerbase with respect to the actual termorder and returns this base as a list of Ore-polynomials. The 'verboselevel' determins the amount of information given while the procedure is advancing, to avoid boredom; the higher this number, the more information will be printed about the progress.";

OreLeftGroebnerLimited::usage = 
    "OreLeftGroebner[l_List, MaxElements_Integer, verboselevel_Integer:0] finds for a given list of Ore-Polynomials a left groebnerbase with respect to the actual termorder and returns this base as a List of Ore-polynomials or the first MaxElements it found, when the algorithm didn't stop until then. The 'verboselevel' determins the amount of information given while the procedure is advancing, avoiding boredom; the higher this number, the more information will be printed about the progress.";

OreMonomialLCM::usage = "OreMonomialLCM[a_OreMonomial,b_OreMonomial] returns the least common multiple of the oremonomials a,b";

OreNormalForm::usage="OreNormalForm[f_OrePolynomial,P_List]:Gives back the normal form of the polynomial with respect to the given list of ore polynomials and the actual order. This ist a truncated version of the division algorithm only regarding the division rest.";

OrePartDivision::usage=" OrePartDivision[a_OrePolynomial,g_OrePolynomial] divides out the leading term of g at the first possible position of a. It returns the result in the form {r, a',g'}, where r = a'*a + g'*g, deg(a')=0 .";

OreRandomPolynomial::usage=
    "OreRandomPolynomial[D_OrePolynomial,k?integer:5, range_List:{-8,8}] creates a random OrePolynomial  of degree k with integer coefficients in a given range.";

OreReduceExtendedGroebnerBasis::usage=
    "OreReduceExtendedGroebnerBasis[G_List, vl_Integer:0,Options_:{}] performs the operation of reducing an extended groebnerbase G while keeping track of of the given presentations - for higher verbosity-levels vl the referred-to basis has to be given as the option BaseGenerators\[Rule]<Referencebase>. ";

OreReduceGroebnerBasis::usage="OreReduceGroebnerBasis[G_List, vl_Integer:0] returns the reduced Groebnerbasis. The optional parameter vl, if greater than 0, gives the verbosity-level for debugging.";

OreReducePolynomial::usage="OreReducePolynomial[s_OrePolynomial,B_List] reduces a polynomial according to a given set of ore polynomials.";

OreTopReduce::usage=" OreTopReduce[a_OrePolynomial,g_OrePolynomial] executes the top-reduction of a with respect to g.";

OreTopReducibleQ::usage="OreTopReducibleQ[a_OrePolynomial,g_OrePolynomial] tests if the leading monomial of a is divided by the one of g. in this case a is top reducible with respect to g.";



Begin["`Private`"]; 

OreAlgebrasVersion="Version 2.6, jan 2006";





InfoMessage[verboselevel_Integer,priority_Integer,MessageText__]:=
    
    If[verboselevel\[GreaterEqual] priority,Print[MessageText]];
SetAttributes[InfoMessage,HoldRest];



OreRandomPolynomial[a_OrePolynomial,k_Integer:5, range_List:{-8,8}] :=
    
    OPo[Random[Integer,range]]+
      Sum[OMu[OPo[Random[Integer,range]],a^i],{i,1,k}];







OreMonomialLCM[a_OreMonomial,b_OreMonomial]:= (* Das 'S-Polynom' Fuer Monome *)

        Module[{L},
      L=Split[Sort[Join[List@@a,List@@b]],First[#1]\[Equal]First[#2]&]; (* 
        Liste der 'Runs'. *)
      
      L=Map[ (* Maxima der auftauchenden Potenzen bilden. *)
          
          If[Length[#]\[Equal]2,
              {#[[1]][[1]], Max[#[[1]][[2]],#[[2]][[2]]]}, (* 
                else *)
              #[[1]]
              ]&,
          L
          ]; (* Map *) 
      OreMonomial@@L (* Als OreMonomial zurueckgeben. *)
      ];





OreTopReducibleQ[a_OrePolynomial,g_OrePolynomial]:=
    
    And@@Thread[
        SummandToVector[First[a]]\[GreaterEqual]SummandToVector[First[g]]];



OreTopReduce[a_OrePolynomial,g_OrePolynomial]:=
    
    If[OreTopReducibleQ[a,g],OreSPoly[a,g],a];



OreTopReduceMemory[a_OrePolynomial,g_OrePolynomial]:=
    
    If[OreTopReducibleQ[a,g],OreExtendedSPolynomial[a,g][[{1,2}]],{a,OreOne}];





OrePartDivision[a_OrePolynomial,g_OrePolynomial,DebugLevel_:0]:=
    
    Module[{aa=a,l,Ra,Rg},
      InfoMessage[DebugLevel,3,"PD: a=",a," g=", g]; 
      While[!(aa<g),
        If[OreTopReducibleQ[aa,g], 
            {l,Ra,Rg}=OreExtendedSPolynomial[aa,g];
            
            Return[{OMu[Ra,a]+OMu[Rg,g],Ra,Rg}] (* 
              erstmoegliches Monom eliminieren *)
            , (* else *)
   
                     
            aa=OreLesserTerms[aa]; (* 
              Rest von a betrachten ... *)
            , (* Weiss nicht *)
   
                     
            Print["Strange error in OrePartDivision[a_OrePolynomial,g_OrePolynomial]"]\
;
            ];
        ];
      Return[{a,OPo[1], OPo[0]}] (* No Division at all. *)
      ];





OreDivision[a_OrePolynomial, g_List, DebugLevel_:0]:=
    Module[
      {rr=a, (* Rest, zunaechst gleich a. *)
        
        cc=Map[OPo[0]&,g], (* Koeffizientenliste, zunaechst alle 0 *)
        
        i, fertig=False,
        ll=OPo[1], llneu, rrneu, restneu},
      InfoMessage[DebugLevel,3,"ODiv: p = ",p," g = ",g];
      While[!fertig,
        fertig=True; (* Noch keinen Kandidaten zur Reduktion gefunden. *)
    
            For[i=1, 
          i\[LessEqual]Length[g], (* 
            Alle Dividenden in Reihenfolge durchtesten. *)
          
          InfoMessage[DebugLevel,2,"Partdiv of ",rr," by ",g[[i]],"= ",
            OrePartDivision[rr,g[[i]]]];
          {restneu,llneu,rrneu}=OrePartDivision[rr,g[[i]],DebugLevel];
          
          InfoMessage[DebugLevel,3,"ODiv: i = ",i,
            " OrePartDivision[rr,g[[i]]] = ",{restneu,llneu,rrneu}];
          If[(rrneu===OPo[0])||(!OreIsUnitQ[llneu]), 
            i++; Continue[], (* war nix ... else *)
            
            fertig=False; (* Eine Reduktion gefunden! *)
            
            rr=restneu; 
            
            ll=OMu[llneu,ll]; (* 
              Den Vorfaktor zum bisherigen aufmultiplizieren *)
            
            InfoMessage[DebugLevel,1,"i = ",i," llneu = ",llneu];
            
            cc=Map[OMu[llneu,#]&,cc]; (* 
              sowie auf die bisherigen Koeffizienten. *)
            
            cc[[i]]=cc[[i]]+rrneu; (* 
              und den momentanen Koeffizienten aktualisieren *)
            
            InfoMessage[DebugLevel,3,"Status: r= ",rr," = ","(",ll,")*", a ,
              " + ", cc,".",g];
            Break[];
            ]; (* If *)
          ];
        InfoMessage[DebugLevel,3,"r=",rr,"=",ll,"*(",a,") + ",g,".",cc];
        ];
      ll=OreInverse[ll];                         (* 
        Die Einheit ll invertieren ... *)
      {OMu[ll,rr],OMu[ll,#]&/@cc}  (* 
        Und die gesuchte Darstellung bestimmen. *)
      ];





OreReducePolynomial[s_OrePolynomial,B_List]:=First[OreDivision[s,B]];







Clear[OreNormalForm];
OreNormalForm[f_OrePolynomial,P_List]:=Module[
      {R,Rfact,
        ff=f,
        PP, i},
      R=OreZero;
      PP=Select[P,!(f<#)&]; (* Zu gro\[SZ]e Terme scheiden gleich aus!*)
     
       PP=Sort[PP,#1<#2&];
      While[ff=!= OreZero && PP=!={},
        i=1;
        While[i\[LessEqual]Length[PP]&&!(OreTopReducibleQ[ff,PP[[i]]]),i++];
        If[i<=Length[PP], 
          {ff,Rfact}=OreTopReduceMemory[ff,PP[[i]]];
          R=OMu[Rfact,R];
          ,
          R=R+OreLeadingSummand[ff]; 
          ff=OreLesserTerms[ff];
          ];
        PP=Select[PP,!(ff<#)&]; (* 
          Zu gro\[SZ]e Terme scheiden aus!*)
        ];(*While*)
      R+ff
      ];





Clear[OreIsLeftGroebner];
OreIsLeftGroebner[G_List,vl_Integer:0]:=
    Module[{B,IArr,h,h0,NumberOfElements=Length[l],Hforms},
      InfoMessage[vl,3,"Start of OreIsLeftGroebner, arguments:",G,", ",
        LengthLimit,", " vl];
      B=Table[Table[OreSPoly[G[[i]],G[[j]]],{i,1,j-1}],{j,2,Length[G]}];
      Hforms=Hold[OreNormalForm[#,G]===OreZero]&/@Flatten[B];
      Return[Release[And@@Hforms]]
      ];





OreLeftGroebner[l_List, vl_Integer:0]:=
    OreLeftGroebnerLimited[l,100,vl];





Clear[OreLeftGroebnerLimited];
OreLeftGroebnerLimited[l_List,LengthLimit_Integer, vl_Integer:0]:=
    
    Module[{G=l, B,IArr, h,h0, NumberOfElements=Length[l]},
      InfoMessage[vl,3,"Start of OreLeftGroebner, arguments:",l,", ",
        LengthLimit,", " vl];
      B=Table[Table[OreSPoly[G[[i]],G[[j]]],{i,1,j-1}],{j,2,Length[G]}];
      B=Sort[Flatten[B],#1<#2&];
      While[(Length[B]>0)&&( Length[G]<LengthLimit), 
        InfoMessage[vl,2,"G is: ",G,"\n B is: ", B];
        h=First[B]; 
        B= Rest[B];                      (* 
          Kleinstes S-Polynom w\[ADoubleDot]hlen. *)
        
        h0=OreNormalForm[h,G]; 
        InfoMessage[vl,3,"Selected from B the S-polynomial = ",h];
        If[ h0=!=OreZero,
          h0=OreEliminateContent[h0];
          
          B= Sort[Flatten[{B,OreSPoly[#,h0]&/@G}],#1<#2&]; (* 
            Alle Paare aus G x {h0} zu B hinzufuegen. *)
          
          G=Append[G,h0];
          
          InfoMessage[vl,1,"As element ",Length[G]," added ",h0," =!= ", 
            OreZero," to G. "];
          ,Null (* else: nothing. *)
          , (* dont know *)
          
          Return["OreLeftGroebner: can't compare ",h0,", ",
              OreZeroPolynomial];
          ](* If *)
        ];(* While Length[B]>0 ... *)
      G
      ]; 





RemoveZeros[L_List]:=Select[L,#=!=OreZero&];



Clear[OreReduceGroebnerBasis];
OreReduceGroebnerBasis[G_List, vl_Integer:0]:=
  
  Module[{GG,Changed,reduced,i},
    GG=RemoveZeros[G]; 
    GG=Sort[GG,#2<#1&]; (* Greatest first. *)
    
    InfoMessage[vl,2,"RGB: sorted Basis: ", GG];
    InfoMessage[vl,4,"simultanous quotients:", 
      Table[OreDivision[GG[[i]],Drop[G,{i}]],
        {i,1,Length[GG]}]
      ];
    Changed=True;
    While[Changed,
      Changed=False;
      For[i=1,i\[LessEqual]Length[GG],i++,
        reduced=First[OreDivision[GG[[i]],Drop[GG,{i}]]];
        If[reduced=!=GG[[i]], 
          Changed=True; 
          If[reduced===OreZero,
            GG=Drop[GG,{i}],
            GG[[i]]=reduced,
            
            InfoMessage[vl,0,
                "RGB: Impossible decision, you should never read this!"];
            ];
          Break[];
          ]; (*if*)
        ]; (*for*)
      ]; (* While *)
    
    OreEliminateContent/@GG
    ];







OreCheckExtended[r_,
      G_]:=(First[r]===
        Sum[OMu[OPo[Last[r][[i]]],G[[i]]],{i,1,Length[Last[r]]}]);





Clear[OreExtendedSPoly];
OreExtendedSPoly[{p_OrePolynomial,lp_List},{q_OrePolynomial,lq_List},
      vl_Integer:0]:=
    Module[{S,lS,a,b},
      {S,a,b}=OreExtendedSPolynomial[p,q]; 
      Return[{S,(OMu[a,#]&/@lp)+(OMu[b,#]&/@lq)}];
      ];



OreExtendedSPolyMemory[{p_OrePolynomial,lp_List},{q_OrePolynomial,lq_List},
      vl_Integer:0]:=
    Module[{S,lS,a,b},
      {S,a,b}=OreExtendedSPolynomial[p,q]; 
      Return[{{S,(OMu[a,#]&/@lp)+(OMu[b,#]&/@lq)},a}];
      ];





Clear[OreExtendedNormalForm];
OreExtendedNormalForm[f_,P_,vl_Integer:0]:=Module[
      {R, Rfact,
        ff=f,
        PP, i},
      R=OreZero; Rfact=OreOne;
      PP=Select[P,!(First[f]<First[#])&]; (* 
        Zu gro\[SZ]e Terme scheiden gleich aus!*)
      
      PP=Sort[PP,First[#1]<First[#2]&];
      While[First[ff]=!= OreZero && PP=!={},
        i=1;
        While[
          i\[LessEqual]Length[
                PP]&&!(OreTopReducibleQ[First[ff],First[PP[[i]]]]),i++];
        If[i<=Length[PP],
          
          InfoMessage[vl,4,"OreExtendedNormalForm: before ff=OreExtendedSPoly[ff,PP[[i]]];\nR=",
            R,"\nff=",ff,"\nPP[[i]]=",PP[[i]]];
          {ff,Rfact}=OreExtendedSPolyMemory[ff,PP[[i]],vl];
          
          InfoMessage[vl,4,"OreExtendedNormalForm:\nR=",R,"\nff=",ff,"\nPP[[i]]=",
            PP[[i]],"Factor for R (must be of zerodegree):",Rfact];
          R=OMu[Rfact,R];
          ,
          
          InfoMessage[vl,4,"OreExtendedNormalForm: cutted. \nR=",R,"\nff=",
            ff];
          R=R+OreLeadingSummand[First[ff]]; 
          ff={OreLesserTerms[First[ff]],Last[ff]};
          InfoMessage[vl,4,"OreExtendedNormalForm:\nR=",R,"\nff=",ff];
          ];
        PP=Select[PP,!(First[ff]<First[#])&]; (* 
          Zu gro\[SZ]e Terme scheiden aus!*)
        ];(*While*)
      {R+
          First[ff],Last[ff]}
      ];







OreUnit[i_Integer,length_Integer]:=
    Table[OPo[KroneckerDelta[i,l]],{l,1,length}];



Clear[OreExtendedLeftGroebnerLimited];
OreExtendedLeftGroebnerLimited[l_List,LengthLimit_Integer, vl_Integer:0]:=
   
     Module[{G, B,IArr, h,h0, NumberOfElements=Length[l]},
      InfoMessage[vl,3,"Start of Extended OreLeftGroebner,\n arguments:",l,", ",
        LengthLimit,", " vl];
      G=Table[{l[[i]],OreUnit[i,NumberOfElements]},{i,1,NumberOfElements}];
      InfoMessage[vl,3,"G:",G];
      B=Table[
          Table[OreExtendedSPoly[G[[i]],G[[j]]],{i,1,j-1}],{j,2,Length[G]}];
      B=Sort[Flatten[B,1],First[#1]<First[#2]&];
      While[(Length[B]>0)&&( Length[G]<LengthLimit), 
        InfoMessage[vl,2,"G is: ",G,"\n B is: ", B];
        h=First[B]; 
        B= Rest[B];                      (* 
          Kleinstes S-Polynom w\[ADoubleDot]hlen. *)
        
        h0=OreExtendedNormalForm[h,G]; 
        InfoMessage[vl,3,"Selected from B the S-polynomial = ",h,"\n with normalform:",
          h0];
        If[ First[h0]=!=OreZero,
          
          B= Sort[Flatten[{B,OreExtendedSPoly[#,h0]&/@G},1],
              First[#1]<First[#2]&]; (* 
            Alle Paare aus G x {h0} zu B hinzufuegen. *)
          
          G=Append[G,h0];
          InfoMessage[vl,1,"Added ",h0," =!= ", OreZero," to G. "];
          ,Null 
          ,
          
          Return["OreLeftGroebner: can't compare ",h0,", ",
              OreZeroPolynomial];
          ];
        ];(* While Length[B]>0 ... *)
      G
      ]; 





Clear[OreDivisionExtended];
Options[OreDivisionExtended]={BaseGenerators\[Rule]Null};
OreDivisionExtended[p_,L_List,vl_Integer:0,options___]:=
    
    Module[{r,koeffs,darst,tmp,G},
      G=((BaseGenerators/.{options})/.Options[OreDivisionExtended]); 
      
      InfoMessage[vl,4,"ODEXT: Eingabe: p = ",p, ", \n geteilt durch L= ",L,"\n Basis der Darstellung: ",
        G,"\nOptions: ",{options}]; 
      
      If[vl>0&&(G===Null), InfoMessage[1,"No base given!"];Abort[]];
      
      {r,koeffs}=OreDivision[First[p],First/@L,vl];
      
      tmp=Table[OMu[koeffs[[i]],#]&/@Last[L[[i]]],
          {i,1,Length[koeffs]}];
      darst=Last[p]+Plus@@tmp;
      If[vl==0|| OreCheckExtended[{r,darst},G], 
        InfoMessage[vl, 3,"ODEXT: f\[UDoubleDot]r ",{r,darst}," korrekt."], 
        InfoMessage[vl, 1,"ODEXT: Darstellung verletzt!"];
        InfoMessage[vl, 2,"ODEXT: Darst = Last[p]+Plus@@tmp = "
          , 
          darst//FullForm];
        InfoMessage[vl, 2,"ODEXT: Returning: ",{{r,darst},koeffs}];Abort[], 
        InfoMessage[vl, 1,"Nicht entscheidbarer Ausdruck:",
          OreCheckExtended[{r,darst},G]]
        ];
      Return[{{r,darst},koeffs}]
      ];





RemoveExtendedZeros[L_List]:=Select[L,First[#]=!=OreZero&];



Clear[OreReduceExtendedGroebnerBasis];
Options[OreReduceExtendedGroebnerBasis]={BaseGenerators\[Rule]Null};

OreReduceExtendedGroebnerBasis[G_List, vl_Integer:0,options___]:=
    
    Module[{GG,Changed,reduced,i, oo},
      oo=Sequence@@
          Flatten[{options,Options[OreReduceExtendedGroebnerBasis]}];
      GG=RemoveExtendedZeros[G]; 
      GG=Sort[GG,First[#2]<First[#1&]]; (* Greatest first. *)
      
      InfoMessage[vl,2,"RGB: sorted Basis: ", GG];
      InfoMessage[vl,3,"simultanous Quotients:", 
        Table[OreDivisionExtended[GG[[i]],Drop[G,{i}],vl,oo],
          {i,1,Length[GG]}]
        ];
      Changed=True;
      While[Changed,
        Changed=False;
        For[i=1,i\[LessEqual]Length[GG],i++,
          reduced=First[OreDivisionExtended[GG[[i]],Drop[GG,{i}],vl,oo]];
          If[reduced=!=GG[[i]], 
            Changed=True; 
            If[First[reduced]===OreZero,
              GG=Drop[GG,{i}],
              GG[[i]]=reduced,
              
              Print["RGB: Internal error. Should be impossible to read this message!"]\
;
              ];
            Break[];
            ]; (*if*)
          ]; (*for*)
        ]; (* While *)
      
      Return[GG]; 
      ]; 



End[];  (* Private Context *)

EndPackage[];
