(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     81846,       2380]*)
(*NotebookOutlinePosition[     82515,       2404]*)
(*  CellTagsIndexPosition[     82471,       2400]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Das Package Ore.m", "Subsection"],

Cell[TextData[{
  "Das ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "-Paket \"Ore.m\" dient dem Umgang mit Ore-Algebren \[UDoubleDot]ber \
\[DoubleStruckCapitalQ].\nEs stellt etliche Operatoren als \"Black Boxes\" \
zur Verf\[UDoubleDot]gung, l\[ADoubleDot]\[SZ]t aber auch beliebige \
Operatorvariablen unter Angabe der \[Sigma] und \[Delta] zu. Eine Wirkung als \
Operator kann man definieren, mu\[SZ] es aber nicht. \nIst jedem Operator \
eine Wirkung zugeordnet, kann man ein Operatorpolynom auf einen Ausdruck \
\"anwenden\". Der Ausdruck mu\[SZ] dabei nicht notwendig ein Polynom sein. \n\
\nDie Grundfunktionen sind:\n\n- Deklaration von Operatoren, \n- Addition, \
Multiplikation, \n- Definieren verschiedener Ordnungen\n- Vergleichen, \
Leitterme extrahieren."
}], "Text"],

Cell[CellGroupData[{

Cell["Die Grundfunktionen", "Subsubsection"],

Cell[TextData[{
  "Wir laden das Paket und schauen die implementierten Funktionen an. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " erlaubt es, auf einfache Weise alle Funktionen anzuzeigen (Die Datei \
Ore.m mu\[SZ] dabei f\[UDoubleDot]r ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " auffindbar sein):"
}], "Text"],

Cell[BoxData[
    \(Needs["\<Ore`\>"]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Ore`*\)\)], "Input"],

Cell[BoxData[GridBox[{
        {
          StyleBox["Ore`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["Delta",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`Delta"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreLeadingSummand",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreLeadingSummand"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["NextDegeneration",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`NextDegeneration"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreLesserTerms",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreLesserTerms"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["NextDegenerationVec",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`NextDegenerationVec"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreListOfOrderObjects",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreListOfOrderObjects"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OMu",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OMu"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreMapOnCoefficients",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreMapOnCoefficients"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["Operation",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`Operation"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreMonomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreMonomial"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OPo",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OPo"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreMultiplication",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreMultiplication"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["Ore",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`Ore"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreNumberOfObjects",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreNumberOfObjects"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreApply",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreApply"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreNumberOfOperators",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreNumberOfOperators"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreCoefficientList",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreCoefficientList"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreNumberOfVariables",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreNumberOfVariables"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreContent",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreContent"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreOne",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreOne"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreCurrentMatrix",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreCurrentMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreOneMonomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreOneMonomial"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDeclareVariables",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDeclareVariables"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreOperatorNames",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreOperatorNames"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineDegLexOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineDegLexOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreOrderData",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreOrderData"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineDiff",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreDefineDiff"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreOrderedListOfObjects",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreOrderedListOfObjects"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineDummy",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineDummy"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OrePolynomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OrePolynomial"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineLexOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineLexOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OrePolynomialsToVectorList",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OrePolynomialsToVectorList"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineOperator",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineOperator"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreRedefineMonomOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreRedefineMonomOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineQDifferentiation",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineQDifferentiation"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreShowStatus",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreShowStatus"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineReverseDegLexOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineReverseDegLexOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreSimplify",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreSimplify"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineReverseLexOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineReverseLexOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreSimplifyCoefficients",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreSimplifyCoefficients"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreDefineShift",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreDefineShift"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreSPoly",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreSPoly"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreEliminateContent",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreEliminateContent"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreSummand",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreSummand"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreExponent",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreExponent"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreTerm",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreTerm"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreExtendedSPolynomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreExtendedSPolynomial"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreVarContent",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreVarContent"},
                  
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreGetMonomOrder",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreGetMonomOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreVarEliminateContent",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreVarEliminateContent"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreInitialTerm",
                    "Hyperlink"],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreInitialTerm"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreVariables",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreVariables"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreInverse",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreInverse"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreVarMonomialQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreVarMonomialQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreIsMonicQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreIsMonicQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreZero",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreZero"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreIsObjectQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreIsObjectQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["OreZeroSummand",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreZeroSummand"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreIsUnitQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`OreIsUnitQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["Sigma",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`Sigma"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreLeadingCoefficient",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreLeadingCoefficient"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["SolvableQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3347624473-9495199", "Ore`SolvableQ"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreLeadingMonomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreLeadingMonomial"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], 
                ButtonBox[
                  StyleBox["SummandToVector",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`SummandToVector"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"]},
              {
                ButtonBox[
                  StyleBox["OreLeadingOperatorMonomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624473-9495199", 
                    "Ore`OreLeadingOperatorMonomial"},
                  ButtonFrame->"None",
                  ButtonNote->"Ore`"], ""}
              },
            
            RowMinHeight->{
              1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
                1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  ButtonBoxOptions->{Active->True},
  GridBoxOptions->{ColumnAlignments->{Left}}]
}, Open  ]],

Cell["An einem Beispiel lernen wir, wie das Paket funktioniert.", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Ein exotischerer Kandidat einer ordnungserhaltenden \
Ore-Algebra\
\>", "Subsection"],

Cell[TextData[{
  "Die Objekte der h\[ADoubleDot]ufigsten Ore-Algebren d\[UDoubleDot]rften \
die Operatoren in der Tabelle von F. Chyzak & B. Salvy aus [ChySal] sein. Die \
Klassiker sind \n\n- Differentiation (stetig), \n- Shift (diskret) und \n- \
q-Differentiation.\n\nDiese algebraischen Objekte entsprechen (manchmal nicht \
eindeutig) \"wirklichen\" Operatoren. Dem algebraischen Objekt D aus der \
Differentialalgebra k\[LeftAngleBracket]X,D\[RightAngleBracket] mit DX=XD+1 \
entspricht eine lineare Operation (D \"wirkt\" auf ein p) auf Funktionen:\n \
Diff: f(X)\[RightTeeArrow]f'(X),\n\n Der Shift aus k\[LeftAngleBracket]n,S\
\[RightAngleBracket] mit S n = (n+1)S entspricht der Wirkung:\n \
f[n]\[Rule]f[n], f(n)\[RightTeeArrow]f(n+1)\n \n Nun finden sich unter den \
ordnungserhaltenden Ore-Algebren weit mehr als diese \"\[UDoubleDot]blichen \
Kandidaten\". \n\nWeder m\[UDoubleDot]ssen die  ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_i\)]],
  " nur von einer Variablen abh\[ADoubleDot]ngen noch homogen sein. Je nach \
Monomordnung k\[ODoubleDot]nnen einige  ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_i\)]],
  " sogar den absoluten Grad erh\[ODoubleDot]hen.\nEs mag dann zwar keine \
Entsprechung als Operatoren auf geeigneten Funktionenr\[ADoubleDot]umen mehr \
geben, dennoch ist es reizvoll auch diese Exoten zu untersuchen. \nDie \
Ore-Algebra mit folgenden Substitutionshomomorphismen und den zugeh\
\[ODoubleDot]rigen inneren Derivationen ist solch ein Beispiel:"
}], "Text"],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_1\)]],
  ": X1\[Rule]X1+X2^2, X2\[Rule]X2\n",
  Cell[BoxData[
      \(TraditionalForm\`\[Delta]\_1\)]],
  ": ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          FormBox[\(P(X\_1, X\_2)\),
            "TraditionalForm"], "\[Rule]", 
          RowBox[{
            FormBox[\(P(X\_1, X\_2)\),
              "TraditionalForm"], "-", \(\(\[Sigma]\_1\)(P)\)}]}], 
        TraditionalForm]]],
  Cell[BoxData[
      \(TraditionalForm\`\((X\_1, X\_2)\)\)]],
  "\n\n",
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_2\)]],
  ": X1\[Rule]X1-X2,X2\[Rule]X2\n",
  Cell[BoxData[
      \(TraditionalForm\`\[Delta]\_2\)]],
  ": ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          FormBox[\(P(X\_1, X\_2)\),
            "TraditionalForm"], "\[Rule]", 
          RowBox[{
            FormBox[\(P(X\_1, X\_2)\),
              "TraditionalForm"], "-", \(\(\[Sigma]\_2\)(P)\)}]}], 
        TraditionalForm]]],
  Cell[BoxData[
      \(TraditionalForm\`\((X\_1, X\_2)\)\)]],
  "\n\nDiese Algebra soll nun mit Hilfe des Paketes Ore.m untersucht werden."
}], "Text"],

Cell[CellGroupData[{

Cell["Deklaration der Unbestimmten", "Subsubsection"],

Cell["\<\
Zur Definition wird ein Symbol angegeben, das nur der Darstellung \
in der Ausgabe  dient, und \[Sigma] und \[Delta] werden durch ihre Wirkung \
auf die Variablen definiert. Da wir hier den Operatoren keine wirkliche \
Operation zuordnun wollen, wird als letztes Argument eine Dummy-Funktion \
\[UDoubleDot]bergeben.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(D\_1 = \ 
      OreDefineOperator[
        D1, \ {X1 \[Rule] X1 + X2^2, X2 \[Rule] X2}, {X1 \[Rule] X2^2, 
          X2 \[Rule] 0}, # &]\), "\n", 
    \(D\_2 = \ 
      OreDefineOperator[
        D2, \ {X1 \[Rule] X1 - X2, X2 \[Rule] X2}, {X1 \[Rule] X2, 
          X2 \[Rule] 0}, # &]\)}], "Input"],

Cell[BoxData[
    \(D1\)], "Output"],

Cell[BoxData[
    \(D2\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Das Zuweisen der Operatoren an ",
  Cell[BoxData[
      \(TraditionalForm\`D\_1\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`D\_2\)]],
  " ist wichtig, denn die Symbole D1, D2 dienen nur der Ausgabe und sind \
keine Ore-Polynome. Viele \[UDoubleDot]bliche Operatoren sind bereits \
vordefiniert.\nWenn wir nun eine Liste der Objekte ausgeben lassen, sehen \
wir, da\[SZ] die auftauchenden Variablen automatisch als Unbestimmte \
registriert wurden:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(OreOrderedListOfObjects\)], "Input"],

Cell[BoxData[
    \({D1, D2, X1, X2}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Ein Tip: Die automatische Erg\[ADoubleDot]nzungsfunktion von ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " funktioniert auch bei den Befehlen aus den nachgeladenen Paketen. Das \
erspart einerseits  Tipparbeit und bietet obendrein ein Men\[UDoubleDot] der \
m\[ODoubleDot]glichen Erg\[ADoubleDot]nzungen. "
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eingabe von Ore-Polynomen", "Subsubsection"],

Cell["\<\
Zur Umwandlung gew\[ODoubleDot]hnlicher Variablen in Ore-Polynome \
dient OrePolynomial, kurz OPo. Dies ist n\[ODoubleDot]tig, da die \
Rechenfunktionen nur mit Ore-Objekten arbeiten.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Px = OPo[X1 + X2]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(X1 + X2\),
      Infix[ 
        OrePolynomial[ 
          OreSummand[ X1, 
            OreMonomial[ ]], 
          OreSummand[ X2, 
            OreMonomial[ ]]], "+"],
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
Die bei den Operatordefinitionen erhaltenen Objekte sind bereits \
Ore-Polynome. Polynome baut man nun mittels der Multiplikation und der \
Addition auf, zur Addition ist nichts weiter Zu sagen, sie funktioniert, wie \
man es denkt:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Px + D\_1\)], "Input"],

Cell[BoxData[
    InterpretationBox[\(D1 + X1 + X2\),
      Infix[ 
        OrePolynomial[ 
          OreSummand[ 1, 
            OreMonomial[ {1, 1}]], 
          OreSummand[ X1, 
            OreMonomial[ ]], 
          OreSummand[ X2, 
            OreMonomial[ ]]], "+"],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiplikation", "Subsubsection"],

Cell[TextData[{
  "F\[UDoubleDot]r die Multiplikation wird der Befehl OreMultiplication, kurz \
OMu verwendet. \nProdukte von ",
  Cell[BoxData[
      \(TraditionalForm\`D\_1\)]],
  " Mit den Variablen ergeben das von ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_1\)]],
  " zu erwartende Resultat:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({OMu[D\_1, OPo[X1]], OMu[D\_1, OPo[X2]]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[
          RowBox[{
            InterpretationBox[\(X1 \*"\<\"\"\>" D1\),
              Infix[ 
                OreSummand[ X1, 
                  OreMonomial[ {1, 1}]], ""],
              Editable->False], "+", 
            InterpretationBox[\(\(X2\^2\) \*"\<\"\"\>" D1\),
              Infix[ 
                OreSummand[ 
                  Power[ X2, 2], 
                  OreMonomial[ {1, 1}]], ""],
              Editable->False], "+", \(X2\^2\)}],
          Infix[ 
            OrePolynomial[ 
              OreSummand[ X1, 
                OreMonomial[ {1, 1}]], 
              OreSummand[ 
                Power[ X2, 2], 
                OreMonomial[ {1, 1}]], 
              OreSummand[ 
                Power[ X2, 2], 
                OreMonomial[ ]]], "+"],
          Editable->False], ",", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D1\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {1, 1}]], ""],
          Editable->False]}], "}"}]], "Output"]
}, Open  ]],

Cell[TextData[{
  "Multiplizieren wir an ",
  Cell[BoxData[
      \(TraditionalForm\`D\_1\)]],
  " nacheinander ",
  Cell[BoxData[
      \(TraditionalForm\`D\_2\)]],
  " und (X1+X2), also Px, ergibt das:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P = OMu[D\_1, D\_2, Px]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        InterpretationBox[
          RowBox[{"X1", "\<\"\"\>", 
            RowBox[{"(", 
              InterpretationBox[\(D1 \*"\<\"\"\>" D2\),
                Infix[ {D1, D2}, ""],
                Editable->False], ")"}]}],
          Infix[ 
            OreSummand[ X1, 
              OreMonomial[ {1, 1}, {2, 1}]], ""],
          Editable->False], "+", 
        InterpretationBox[
          RowBox[{\(X2\^2\), "\<\"\"\>", 
            RowBox[{"(", 
              InterpretationBox[\(D1 \*"\<\"\"\>" D2\),
                Infix[ {D1, D2}, ""],
                Editable->False], ")"}]}],
          Infix[ 
            OreSummand[ 
              Power[ X2, 2], 
              OreMonomial[ {1, 1}, {2, 1}]], ""],
          Editable->False], "+", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D1\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {1, 1}]], ""],
          Editable->False], "+", 
        InterpretationBox[\(\(X2\^2\) \*"\<\"\"\>" D2\),
          Infix[ 
            OreSummand[ 
              Power[ X2, 2], 
              OreMonomial[ {2, 1}]], ""],
          Editable->False]}],
      Infix[ 
        OrePolynomial[ 
          OreSummand[ X1, 
            OreMonomial[ {1, 1}, {2, 1}]], 
          OreSummand[ 
            Power[ X2, 2], 
            OreMonomial[ {1, 1}, {2, 1}]], 
          OreSummand[ X2, 
            OreMonomial[ {1, 1}]], 
          OreSummand[ 
            Power[ X2, 2], 
            OreMonomial[ {2, 1}]]], "+"],
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  "Die Ausgabe von P ist durch eine eigene Darstellungsfunktion lesbarer \
gehalten. Die interne Darstellung offenbart der ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "-Befehl FullForm:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[P]\)], "Input"],

Cell[BoxData[
    TagBox[
      StyleBox[\(OrePolynomial[
          OreSummand[X1, OreMonomial[List[1, 1], List[2, 1]]], 
          OreSummand[Power[X2, 2], OreMonomial[List[1, 1], List[2, 1]]], 
          OreSummand[X2, OreMonomial[List[1, 1]]], 
          OreSummand[Power[X2, 2], OreMonomial[List[2, 1]]]]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Vergleiche, Abrufen und \[CapitalADoubleDot]ndern der Ordnung", \
"Subsubsection"],

Cell["\<\
Die aktuelle Algebra mit der aktuellen Ordnung ist \
ordnungserhaltend. Den Test darauf leistet der Befehl \"SolvableQ\":\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SolvableQ\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Die Defaultordnung auf den Monomen ist lexikografisch, wobei die \
Operatoren gr\[ODoubleDot]\[SZ]er als die Variablen sind. Ansonsten gilt die \
Reihenfolge der Deklaration:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(OPo[X2] < OPo[X1]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Wir merken uns die aktuelle (defaultm\[ADoubleDot]\[SZ]ig \
lexikografische) Ordnung:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(merk = OreGetMonomOrder[]\)], "Input"],

Cell[BoxData[
    \({{D1, D2, X1, 
        X2}, {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
          1}}}\)], "Output"]
}, Open  ]],

Cell["\<\
Nun tauschen wir die Reihenfolge der Variablen in der \
lexikografischen Ordnung:\
\>", "Text"],

Cell[BoxData[
    \(OreRedefineMonomOrder[{X2, X1, D\_1, D\_2}, 
      IdentityMatrix[4]]\)], "Input"],

Cell["Nun ist X2 nicht mehr kleiner als X1:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(OPo[X2] < OPo[X1]\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]],

Cell["Und die Algebra ist nun nicht mehr ordnungserhaltend!", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SolvableQ\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]],

Cell["\<\
Nehmen wir nun eine Monomordnung, die n\[ADoubleDot]her an einer \
Gesamtgrad-Ordnung liegt. Mit etwas Probieren kommt man auf die folgende \
Matrixordnung:\
\>", "Text"],

Cell[BoxData[
    \(OreRedefineMonomOrder[{D\_1, D\_2, X1, 
        X2}, {{3, 3, 3, 1}, {0, 1, 1, 1}, {0, 0, 1, 1}, {0, 0, 0, 
          1}}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SolvableQ\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Die Ordnung spielt f\[UDoubleDot]r Gr\[ODoubleDot]bnerbasen eine \
wichtige Rolle. Die Algorithmen hierf\[UDoubleDot]r befinden sich im Paket \
\"OreAlgorithms.m\". Schon jetzt k\[ODoubleDot]nnen wir den folgenden Satz \
aus der Arbeit am vorliegenden Beispiel pr\[UDoubleDot]fen:\
\>", "Text"],

Cell["\<\
 A,B seien Matrizen zu Ordnungen bez\[UDoubleDot]glich derer unsere \
Ore-Algebra ordnungserhaltend ist. Dann ist die Leitform von A, verfeinert \
durch die Matrix B ordnungserhaltend (Satz 6.1).\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(A = IdentityMatrix[4]; 
    B = {{3, 3, 3, 1}, {0, 1, 1, 1}, {0, 0, 1, 1}, {0, 0, 0, 1}}; 
    F = Drop[Prepend[B, First[A]], \(-1\)]\)], "Input"],

Cell[BoxData[
    \({{1, 0, 0, 0}, {3, 3, 3, 1}, {0, 1, 1, 1}, {0, 0, 1, 1}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(OreRedefineMonomOrder[{D\_1, D\_2, X1, X2}, F]; SolvableQ\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Und weiter k\[ODoubleDot]nnen wir einige Ordnungen zwischen \"F\" \
und \"B\" nehmen, um (6.4) zu testen.  Wir betrachten zehn \
zuf\[ADoubleDot]llige Leitgewichte zwischen A[[1]] und B[[1]] und erg\
\[ADoubleDot]nzen sie durch B:\
\>", "Text"],

Cell[BoxData[{
    \(\(zuf = Table[Random[], {10}];\)\), "\[IndentingNewLine]", 
    \(\(gewichte = 
        Map[#*First[A] + \((1 - #)\)*First[B] &, 
          zuf];\)\), "\[IndentingNewLine]", 
    \(\(Zwi = Map[Drop[Prepend[B, #], \(-1\)] &, gewichte];\)\)}], "Input"],

Cell["und testen die Solvable-Bedingung f\[UDoubleDot]r alle Ordnungen:", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(merk = OreGetMonomOrder[]; Ergebnis = True;\), "\[IndentingNewLine]", 
    \(For[i = 1, 
      i \[LessEqual] 
        10, \(i++\), \[IndentingNewLine]OreRedefineMonomOrder[{D\_1, D\_2, 
          X1, X2}, Zwi[\([i]\)]]; 
      Ergebnis = Ergebnis && SolvableQ;\[IndentingNewLine]]; 
    Ergebnis\), "\[IndentingNewLine]", 
    \(\(OreRedefineMonomOrder[Sequence @@ merk];\)\)}], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Dabei wurde darauf geachtet, die Monomordnung wieder herzustellen. \
Das vermeidet unliebsame \[CapitalUDoubleDot]beraschungen.\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["H\[ODoubleDot]here Algorithmen: Das Paket OreAlgorithms", "Subsection"],

Cell["\<\
Dieses Paket baut auf Ore.m auf, hier sind komplexere Algorithmen \
realisiert. \
\>", "Text"],

Cell[BoxData[
    \(Needs["\<OreAlgorithms`\>"]\)], "Input"],

Cell["Schauen wir uns die hinzugekommenen Funktionen an:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?OreAlgorithms`*\)\)], "Input"],

Cell[BoxData[GridBox[{
        {
          StyleBox["OreAlgorithms`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["BaseGenerators",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`BaseGenerators"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreLeftGroebner",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreLeftGroebner"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["InfoMessage",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`InfoMessage"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreLeftGroebnerLimited",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreLeftGroebnerLimited"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreAlgebrasVersion",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreAlgebrasVersion"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreMonomialLCM",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreMonomialLCM"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreCheckExtended",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreCheckExtended"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreNormalForm",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreNormalForm"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreDivision",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreDivision"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OrePartDivision",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OrePartDivision"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreDivisionExtended",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreDivisionExtended"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreRandomPolynomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreRandomPolynomial"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreExtendedLeftGroebnerLimited",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreExtendedLeftGroebnerLimited"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreReduceExtendedGroebnerBasis",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreReduceExtendedGroebnerBasis"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreExtendedNormalForm",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreExtendedNormalForm"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreReduceGroebnerBasis",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreReduceGroebnerBasis"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreExtendedSPoly",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreExtendedSPoly"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreReducePolynomial",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreReducePolynomial"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreGCD",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreGCD"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreTopReduce",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreTopReduce"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]},
              {
                ButtonBox[
                  StyleBox["OreIsLeftGroebner",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreIsLeftGroebner"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"], 
                ButtonBox[
                  StyleBox["OreTopReducibleQ",
                    "Hyperlink"],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3347624475-7623989", 
                    "OreAlgorithms`OreTopReducibleQ"},
                  ButtonFrame->"None",
                  ButtonNote->"OreAlgorithms`"]}
              },
            RowMinHeight->{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  ButtonBoxOptions->{Active->True},
  GridBoxOptions->{ColumnAlignments->{Left}}]
}, Open  ]],

Cell["\<\
Es geht in erster Linie um Gr\[ODoubleDot]bnerbasisberechnungen und \
Funktionen im Umfeld davon. F\[UDoubleDot]r \
Gr\[ODoubleDot]bnerbasisberechnungen wird der (kaum optimierte) Algorithmus \
von Buchberger verwendet. F\[UDoubleDot]r ordnungserhaltende Algebren \
funktioniert das Verfahren garantiert. 
Allerdings gibt es einen etwas ungewohnten Effekt: Eine Menge von Monomen mu\
\[SZ] nun keine Gr\[ODoubleDot]bnerbasis darstellen! 
Wir betrachten in unserer exotischen Algebra folgende Monome:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(OreRedefineMonomOrder[{D\_1, D\_2, X1, 
        X2}, {{3, 3, 3, 1}, {0, 1, 1, 1}, {0, 0, 1, 1}, {0, 0, 0, 
          1}}]\), "\n", 
    \(P = {D\_1, OMu[OPo[X2], D\_2], OPo[X1^2]}\)}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"D1", ",", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {2, 1}]], ""],
          Editable->False], ",", \(X1\^2\)}], "}"}]], "Output"]
}, Open  ]],

Cell["Bilden wir nun die reduzierte Gr\[ODoubleDot]bnerbasis ...", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(G = OreReduceGroebnerBasis[OreLeftGroebner[P]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(X1\^2\), ",", \(\(-X1\)\ X2\^2\), ",", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {2, 1}]], ""],
          Editable->False], ",", \(X2\^3\), ",", "D1"}], "}"}]], "Output"]
}, Open  ]],

Cell[TextData[{
  "... so stellen wir fest, da\[SZ] neue Elemente auftauchen. Das beruht \
darauf, da\[SZ] ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sigma]\_1\)]],
  " hier Potenzen von X2 generiert!"
}], "Text"],

Cell["\<\
Gehen wir in die lexikografische Ordnung, und betrachten ein \
anderes Ideal:\
\>", "Text"],

Cell[BoxData[
    \(\(OreDefineLexOrder;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(P1 = {D\_1 + OPo[X1], OMu[OPo[X2], D\_2], OPo[X1^2]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(D1 + X1\),
          Infix[ 
            OrePolynomial[ 
              OreSummand[ 1, 
                OreMonomial[ {1, 1}]], 
              OreSummand[ X1, 
                OreMonomial[ ]]], "+"],
          Editable->False], ",", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {2, 1}]], ""],
          Editable->False], ",", \(X1\^2\)}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[G = OreReduceGroebnerBasis[OreLeftGroebner[P1]]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(0.14697799999999994`\ Second\), ",", 
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[\(D1 + X1\),
              Infix[ 
                OrePolynomial[ 
                  OreSummand[ 1, 
                    OreMonomial[ {1, 1}]], 
                  OreSummand[ X1, 
                    OreMonomial[ ]]], "+"],
              Editable->False], ",", 
            InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
              Infix[ 
                OreSummand[ X2, 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False], ",", \(X1\^2\), ",", \(X2\^2\)}], "}"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(OreRedefineMonomOrder[{D\_1, D\_2, X1, 
          X2}, {{3, 3, 3, 1}, {0, 1, 1, 1}, {0, 0, 1, 1}, {0, 0, 0, 
            1}}];\)\), "\[IndentingNewLine]", 
    \(P1 = OreSimplify /@ P1\)}], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[\(X1 + D1\),
          Infix[ 
            OrePolynomial[ 
              OreSummand[ X1, 
                OreMonomial[ ]], 
              OreSummand[ 1, 
                OreMonomial[ {1, 1}]]], "+"],
          Editable->False], ",", 
        InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
          Infix[ 
            OreSummand[ X2, 
              OreMonomial[ {2, 1}]], ""],
          Editable->False], ",", \(X1\^2\)}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Das Simplify ist hier wichtig: Es stellt die korrekte interne \
Darstellung nach einer Ordnungs\[ADoubleDot]nderung wieder her. Die \
Darstellung des ersten Elementes hat sich in der neuen Ordnung ver\
\[ADoubleDot]ndert!\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing[G = OreReduceGroebnerBasis[OreLeftGroebner[P1]]]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(0.42393600000000004`\ Second\), ",", 
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[\(\((\(-1\))\) \*"\<\"\"\>" D1\^2\),
              Infix[ 
                OreSummand[ -1, 
                  OreMonomial[ {1, 2}]], ""],
              Editable->False], ",", 
            InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
              Infix[ 
                OreSummand[ X2, 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False], ",", 
            InterpretationBox[\(X1 + D1\),
              Infix[ 
                OrePolynomial[ 
                  OreSummand[ X1, 
                    OreMonomial[ ]], 
                  OreSummand[ 1, 
                    OreMonomial[ {1, 1}]]], "+"],
              Editable->False], ",", \(X2\^2\)}], "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Hier hat sich mit der Ordnung die Gr\[ODoubleDot]bnerbasis ge\
\[ADoubleDot]ndert. 
Erw\[ADoubleDot]hnenswert d\[UDoubleDot]rfte noch die \"extended\"-Version \
der Gr\[ODoubleDot]bnerbasisberechnung sein. Sie versorgt uns noch mit einer \
Darstellung durch die alte Idealbasis. Das Anh\[ADoubleDot]ngsel \"Limited\" \
bedeutet, da\[SZ] eine obere Schranke angegeben wird, bei der die Berechnung \
weiterer S-Polynome abgebrochen wird:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(EG = OreExtendedLeftGroebnerLimited[P1, 10]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[\(X1 + D1\),
              Infix[ 
                OrePolynomial[ 
                  OreSummand[ X1, 
                    OreMonomial[ ]], 
                  OreSummand[ 1, 
                    OreMonomial[ {1, 1}]]], "+"],
              Editable->False], ",", \({1, 0, 0}\)}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
              Infix[ 
                OreSummand[ X2, 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False], ",", \({0, 1, 0}\)}], "}"}], 
        ",", \({X1\^2, {0, 0, 1}}\), ",", 
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[
              RowBox[{
                InterpretationBox[\(\((\(-1\))\) \*"\<\"\"\>" D1\^2\),
                  Infix[ 
                    OreSummand[ -1, 
                      OreMonomial[ {1, 2}]], ""],
                  Editable->False], "+", 
                InterpretationBox[\(\((\(-X2\^2\))\) \*"\<\"\"\>" D1\),
                  Infix[ 
                    OreSummand[ 
                      Times[ -1, 
                        Power[ X2, 2]], 
                      OreMonomial[ {1, 1}]], ""],
                  Editable->False], "+", \(-X2\^2\)}],
              Infix[ 
                OrePolynomial[ 
                  OreSummand[ -1, 
                    OreMonomial[ {1, 2}]], 
                  OreSummand[ 
                    Times[ -1, 
                      Power[ X2, 2]], 
                    OreMonomial[ {1, 1}]], 
                  OreSummand[ 
                    Times[ -1, 
                      Power[ X2, 2]], 
                    OreMonomial[ ]]], "+"],
              Editable->False], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                  RowBox[{"X1", "+", 
                    InterpretationBox[\(\((\(-1\))\) \*"\<\"\"\>" D1\),
                      Infix[ 
                        OreSummand[ -1, 
                          OreMonomial[ {1, 1}]], ""],
                      Editable->False]}],
                  Infix[ 
                    OrePolynomial[ 
                      OreSummand[ X1, 
                        OreMonomial[ ]], 
                      OreSummand[ -1, 
                        OreMonomial[ {1, 1}]]], "+"],
                  Editable->False], ",", "0", ",", \(-1\)}], "}"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
          RowBox[{\(X2\^2\), ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[\(X2 \*"\<\"\"\>" D2\),
                  Infix[ 
                    OreSummand[ X2, 
                      OreMonomial[ {2, 1}]], ""],
                  Editable->False], ",", 
                InterpretationBox[
                  RowBox[{\(-X1\), "+", 
                    InterpretationBox[\(\((\(-1\))\) \*"\<\"\"\>" D1\),
                      Infix[ 
                        OreSummand[ -1, 
                          OreMonomial[ {1, 1}]], ""],
                      Editable->False], "+", "X2"}],
                  Infix[ 
                    OrePolynomial[ 
                      OreSummand[ 
                        Times[ -1, X1], 
                        OreMonomial[ ]], 
                      OreSummand[ -1, 
                        OreMonomial[ {1, 1}]], 
                      OreSummand[ X2, 
                        OreMonomial[ ]]], "+"],
                  Editable->False], ",", "0"}], "}"}]}], "}"}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Wir testen es am letzten Element: Der erste Eintrag mu\[SZ] aus den \
Idealelementen mit den Koeffizienten aus der mitgelieferten Liste \
hervorgehen:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(L = \(Last[EG]\)[\([2]\)];\)\), "\[IndentingNewLine]", 
    \(OMu[L[\([1]\)], P1[\([1]\)]] + OMu[L[\([2]\)], P1[\([2]\)]] + 
      OMu[L[\([3]\)], P1[\([3]\)]]\)}], "Input"],

Cell[BoxData[
    \(X2\^2\)], "Output"]
}, Open  ]],

Cell["\<\
Das ist in der Tat der erste Eintrag. Die Extended-Versionen der \
anderen Befehle arbeiten mit diesen Paaren statt mit einfachen Ore-Polynomen.\
\
\>", "Text"],

Cell[CellGroupData[{

Cell[TextData[{
  "Zusammenarbeit mit ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Subsubsection"],

Cell["\<\
Problem: 
Wir haben Funktionalgleichungen, in denen Shifts und Differenzieren vorkommt \
und suchen eine L\[ODoubleDot]sungsfunktion. Die Gleichungen sind zum \
Beispiel:
 
f(X,n+1)-X f(X,n) = 0     und    3 f(X,n+2)- 4 X^2 f'(X,n) = 0.

Vorgehen:
Durch Angabe einer geeigneten Termordnung lassen wir den Shift in der Gr\
\[ODoubleDot]bnerbasis des Verschwindungsideales bevorzugt eliminieren.  So \
erhalten wir eine DGL, die mit Standardmethoden gel\[ODoubleDot]st wird. 
Wir fangen ganz von vorne an:\
\>", "Text"],

Cell[BoxData[
    \(\(Quit[];\)\)], "Input"],

Cell[BoxData[{
    \(\(Needs["\<OreAlgorithms`\>"];\)\), "\n", 
    \(\(NShift = OreDefineShift[Sn, \ n];\)\), "\n", 
    \(\(Diff = \ OreDefineDiff[Dx, \ X];\)\)}], "Input"],

Cell["\<\
Das sind die gewohnten Operatoren, die auf Ausdr\[UDoubleDot]cke \
anwendbar sind , z.B.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({OreApply[NShift, \((X*n)\)^2], OreApply[Diff, \((X*n)\)^2]}\)], "Input"],

Cell[BoxData[
    \({\((1 + n)\)\^2\ X\^2, 2\ n\^2\ X}\)], "Output"]
}, Open  ]],

Cell["Unsere Monomordnung soll den Shift h\[ODoubleDot]her gewichten:", "Text"],

Cell[BoxData[
    \(OreRedefineMonomOrder[{NShift, Diff, n, X}, 
      IdentityMatrix[4]]\)], "Input"],

Cell["\<\
Es folgen unsere Funktionalgleichungen (wobei nach X abzuleiten \
ist): \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(A1 = NShift - OMu[OPo[X], Diff]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"Sn", "+", 
        InterpretationBox[\(\((\(-X\))\) \*"\<\"\"\>" Dx\),
          Infix[ 
            OreSummand[ 
              Times[ -1, X], 
              OreMonomial[ {2, 1}]], ""],
          Editable->False]}],
      Infix[ 
        OrePolynomial[ 
          OreSummand[ 1, 
            OreMonomial[ {1, 1}]], 
          OreSummand[ 
            Times[ -1, X], 
            OreMonomial[ {2, 1}]]], "+"],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(A2 = 3\ NShift^2 - 4\ OMu[OPo[X^2], Diff^2]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        InterpretationBox[\(3 \*"\<\"\"\>" Sn\^2\),
          Infix[ 
            OreSummand[ 3, 
              OreMonomial[ {1, 2}]], ""],
          Editable->False], "+", 
        InterpretationBox[\(\((\(-4\)\ X\^2)\) \*"\<\"\"\>" Dx\^2\),
          Infix[ 
            OreSummand[ 
              Times[ -4, 
                Power[ X, 2]], 
              OreMonomial[ {2, 2}]], ""],
          Editable->False]}],
      Infix[ 
        OrePolynomial[ 
          OreSummand[ 3, 
            OreMonomial[ {1, 2}]], 
          OreSummand[ 
            Times[ -4, 
              Power[ X, 2]], 
            OreMonomial[ {2, 2}]]], "+"],
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
Berechnen der Gr\[ODoubleDot]bnerbasis eliminiert hier den Shift. \
Mit \"verboselevel 1\"  werden wir \[UDoubleDot]ber den Fortschritt des \
Buchbergeralgorithmus unterrichtet. In komplizierteren Beispielen k\
\[ODoubleDot]nnte man so eventuell erkennen, da\[SZ] gar nicht die ganze \
Basis berechnet werden mu\[SZ].\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(GB = OreLeftGroebner[{A1, A2}, 1]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"As element \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\" added \"\>", "\[InvisibleSpace]", 
        InterpretationBox[
          RowBox[{
            InterpretationBox[\(\(X\^2\) \*"\<\"\"\>" Dx\^2\),
              Infix[ 
                OreSummand[ 
                  Power[ X, 2], 
                  OreMonomial[ {2, 2}]], ""],
              Editable->False], "+", 
            InterpretationBox[\(\((\(-3\)\ X)\) \*"\<\"\"\>" Dx\),
              Infix[ 
                OreSummand[ 
                  Times[ -3, X], 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False]}],
          Infix[ 
            OrePolynomial[ 
              OreSummand[ 
                Power[ X, 2], 
                OreMonomial[ {2, 2}]], 
              OreSummand[ 
                Times[ -3, X], 
                OreMonomial[ {2, 1}]]], "+"],
          Editable->False], "\[InvisibleSpace]", "\<\" =!= \"\>", 
        "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\" to G. \"\>"}],
      SequenceForm[ "As element ", 3, " added ", 
        OrePolynomial[ 
          OreSummand[ 
            Power[ X, 2], 
            OreMonomial[ {2, 2}]], 
          OreSummand[ 
            Times[ -3, X], 
            OreMonomial[ {2, 1}]]], " =!= ", 
        OrePolynomial[ 
          OreSummand[ 0, 
            OreMonomial[ ]]], " to G. "],
      Editable->False]], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        InterpretationBox[
          RowBox[{"Sn", "+", 
            InterpretationBox[\(\((\(-X\))\) \*"\<\"\"\>" Dx\),
              Infix[ 
                OreSummand[ 
                  Times[ -1, X], 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False]}],
          Infix[ 
            OrePolynomial[ 
              OreSummand[ 1, 
                OreMonomial[ {1, 1}]], 
              OreSummand[ 
                Times[ -1, X], 
                OreMonomial[ {2, 1}]]], "+"],
          Editable->False], ",", 
        InterpretationBox[
          RowBox[{
            InterpretationBox[\(3 \*"\<\"\"\>" Sn\^2\),
              Infix[ 
                OreSummand[ 3, 
                  OreMonomial[ {1, 2}]], ""],
              Editable->False], "+", 
            InterpretationBox[\(\((\(-4\)\ X\^2)\) \*"\<\"\"\>" Dx\^2\),
              Infix[ 
                OreSummand[ 
                  Times[ -4, 
                    Power[ X, 2]], 
                  OreMonomial[ {2, 2}]], ""],
              Editable->False]}],
          Infix[ 
            OrePolynomial[ 
              OreSummand[ 3, 
                OreMonomial[ {1, 2}]], 
              OreSummand[ 
                Times[ -4, 
                  Power[ X, 2]], 
                OreMonomial[ {2, 2}]]], "+"],
          Editable->False], ",", 
        InterpretationBox[
          RowBox[{
            InterpretationBox[\(\(X\^2\) \*"\<\"\"\>" Dx\^2\),
              Infix[ 
                OreSummand[ 
                  Power[ X, 2], 
                  OreMonomial[ {2, 2}]], ""],
              Editable->False], "+", 
            InterpretationBox[\(\((\(-3\)\ X)\) \*"\<\"\"\>" Dx\),
              Infix[ 
                OreSummand[ 
                  Times[ -3, X], 
                  OreMonomial[ {2, 1}]], ""],
              Editable->False]}],
          Infix[ 
            OrePolynomial[ 
              OreSummand[ 
                Power[ X, 2], 
                OreMonomial[ {2, 2}]], 
              OreSummand[ 
                Times[ -3, X], 
                OreMonomial[ {2, 1}]]], "+"],
          Editable->False]}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Hier sieht man: Die Variable X in dem neuen Basiselement kann man \
ausklammern. Dieser Linksfaktor ist f\[UDoubleDot]r die Gleichung P*f=0 \
unerheblich. 
Wir eliminieren ihn mit OreVarEliminateContent:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(reduced = OreVarEliminateContent[Last[GB]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        InterpretationBox[\(X \*"\<\"\"\>" Dx\^2\),
          Infix[ 
            OreSummand[ X, 
              OreMonomial[ {2, 2}]], ""],
          Editable->False], "+", 
        InterpretationBox[\(\((\(-3\))\) \*"\<\"\"\>" Dx\),
          Infix[ 
            OreSummand[ -3, 
              OreMonomial[ {2, 1}]], ""],
          Editable->False]}],
      Infix[ 
        OrePolynomial[ 
          OreSummand[ X, 
            OreMonomial[ {2, 2}]], 
          OreSummand[ -3, 
            OreMonomial[ {2, 1}]]], "+"],
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  "Diesem Ore-Polynom entspricht eine Differentialgleichung, die mit \
standard-",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "-Methoden behandelt werden kann: \"OreApply\" f\[UDoubleDot]hrt uns in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s Welt zur\[UDoubleDot]ck:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DGL = OreApply[GB[\([3]\)], f[X, n]]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-3\), " ", "X", " ", 
        RowBox[{
          SuperscriptBox["f", 
            TagBox[\((1, 0)\),
              Derivative],
            MultilineFunction->None], "[", \(X, n\), "]"}]}], "+", 
      RowBox[{\(X\^2\), " ", 
        RowBox[{
          SuperscriptBox["f", 
            TagBox[\((2, 0)\),
              Derivative],
            MultilineFunction->None], "[", \(X, n\), "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Solution = DSolve[DGL \[Equal] 0, f[X, n], X]\)], "Input"],

Cell[BoxData[
    \({{f[X, n] \[Rule] 1\/4\ X\^4\ C[1] + C[2]}}\)], "Output"]
}, Open  ]],

Cell["\<\
Hier finden sich zwei Konstanten. Diese h\[ADoubleDot]ngen nat\
\[UDoubleDot]rlich noch von n ab:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Solution = Solution /. {C[t_] \[Rule] \ C[t, n]}\)], "Input"],

Cell[BoxData[
    \({{f[X, n] \[Rule] 1\/4\ X\^4\ C[1, n] + C[2, n]}}\)], "Output"]
}, Open  ]],

Cell["\<\
Wir wenden nun den Operator A1 an, um diese Konstanten durch \
Koeffizientenvergleich zu bestimmen:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Collect[OreApply[A1, f[X, n] /. Solution\ ], X]\)], "Input"],

Cell[BoxData[
    \({X\^4\ \((\(-C[1, n]\) + 1\/4\ C[1, 1 + n])\) + 
        C[2, 1 + n]}\)], "Output"]
}, Open  ]],

Cell["\<\
Dies mu\[SZ] identisch Null sein, es folgt C[2,n]=0 sowie \
c[1,n+1]=4*C[1,n], also
induktiv: c[1,n] = c 4^n mit C[1,0]=c.

Damit erhalten wir notwendig als L\[ODoubleDot]sung:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({F} = \(f[X, n] /. Solution\) /. {C[2, n] \[Rule] \ 0, \ 
          C[1, n] \[Rule] C\ 4^n}\)], "Input"],

Cell[BoxData[
    \({4\^\(\(-1\) + n\)\ C\ X\^4}\)], "Output"]
}, Open  ]],

Cell["Die Probe zeigt, da\[SZ] unsere L\[ODoubleDot]sung auch stimmt:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({OreApply[A1, F], OreApply[A2, F]}\)], "Input"],

Cell[BoxData[
    \({0, 0}\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.1 for X",
ScreenRectangle->{{0, 1280}, {0, 800}},
WindowSize->{1065, 770},
WindowMargins->{{46, Automatic}, {Automatic, 68}},
ShowSelection->True,
Magnification->2
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 39, 0, 78, "Subsection"],
Cell[1818, 55, 793, 14, 444, "Text"],

Cell[CellGroupData[{
Cell[2636, 73, 44, 0, 52, "Subsubsection"],
Cell[2683, 75, 341, 9, 124, "Text"],
Cell[3027, 86, 50, 1, 52, "Input"],

Cell[CellGroupData[{
Cell[3102, 91, 43, 1, 52, "Input"],
Cell[3148, 94, 31252, 781, 1170, "Print"]
}, Open  ]],
Cell[34415, 878, 73, 0, 60, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[34537, 884, 95, 3, 116, "Subsection"],
Cell[34635, 889, 1519, 24, 828, "Text"],
Cell[36157, 915, 1130, 37, 252, "Text"],

Cell[CellGroupData[{
Cell[37312, 956, 53, 0, 52, "Subsubsection"],
Cell[37368, 958, 340, 6, 156, "Text"],

Cell[CellGroupData[{
Cell[37733, 968, 320, 8, 142, "Input"],
Cell[38056, 978, 36, 1, 52, "Output"],
Cell[38095, 981, 36, 1, 52, "Output"]
}, Open  ]],
Cell[38146, 985, 489, 12, 188, "Text"],

Cell[CellGroupData[{
Cell[38660, 1001, 56, 1, 52, "Input"],
Cell[38719, 1004, 50, 1, 52, "Output"]
}, Open  ]],
Cell[38784, 1008, 350, 7, 124, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39171, 1020, 50, 0, 52, "Subsubsection"],
Cell[39224, 1022, 207, 4, 92, "Text"],

Cell[CellGroupData[{
Cell[39456, 1030, 50, 1, 52, "Input"],
Cell[39509, 1033, 241, 8, 52, "Output"]
}, Open  ]],
Cell[39765, 1044, 256, 5, 124, "Text"],

Cell[CellGroupData[{
Cell[40046, 1053, 42, 1, 52, "Input"],
Cell[40091, 1056, 308, 10, 52, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[40448, 1072, 39, 0, 52, "Subsubsection"],
Cell[40490, 1074, 319, 9, 92, "Text"],

Cell[CellGroupData[{
Cell[40834, 1087, 73, 1, 52, "Input"],
Cell[40910, 1090, 1063, 31, 59, "Output"]
}, Open  ]],
Cell[41988, 1124, 216, 8, 60, "Text"],

Cell[CellGroupData[{
Cell[42229, 1136, 56, 1, 52, "Input"],
Cell[42288, 1139, 1568, 47, 55, "Output"]
}, Open  ]],
Cell[43871, 1189, 227, 6, 92, "Text"],

Cell[CellGroupData[{
Cell[44123, 1199, 44, 1, 52, "Input"],
Cell[44170, 1202, 441, 10, 227, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[44660, 1218, 88, 1, 52, "Subsubsection"],
Cell[44751, 1221, 147, 4, 92, "Text"],

Cell[CellGroupData[{
Cell[44923, 1229, 42, 1, 52, "Input"],
Cell[44968, 1232, 38, 1, 77, "Output"]
}, Open  ]],
Cell[45021, 1236, 198, 4, 92, "Text"],

Cell[CellGroupData[{
Cell[45244, 1244, 50, 1, 52, "Input"],
Cell[45297, 1247, 38, 1, 77, "Output"]
}, Open  ]],
Cell[45350, 1251, 109, 3, 60, "Text"],

Cell[CellGroupData[{
Cell[45484, 1258, 58, 1, 52, "Input"],
Cell[45545, 1261, 130, 3, 107, "Output"]
}, Open  ]],
Cell[45690, 1267, 105, 3, 60, "Text"],
Cell[45798, 1272, 102, 2, 52, "Input"],
Cell[45903, 1276, 53, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[45981, 1280, 50, 1, 52, "Input"],
Cell[46034, 1283, 39, 1, 77, "Output"]
}, Open  ]],
Cell[46088, 1287, 69, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[46182, 1291, 42, 1, 52, "Input"],
Cell[46227, 1294, 39, 1, 77, "Output"]
}, Open  ]],
Cell[46281, 1298, 180, 4, 92, "Text"],
Cell[46464, 1304, 154, 3, 82, "Input"],

Cell[CellGroupData[{
Cell[46643, 1311, 42, 1, 52, "Input"],
Cell[46688, 1314, 38, 1, 77, "Output"]
}, Open  ]],
Cell[46741, 1318, 304, 5, 124, "Text"],
Cell[47048, 1325, 219, 4, 124, "Text"],

Cell[CellGroupData[{
Cell[47292, 1333, 166, 3, 112, "Input"],
Cell[47461, 1338, 90, 1, 77, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[47588, 1344, 90, 1, 82, "Input"],
Cell[47681, 1347, 38, 1, 77, "Output"]
}, Open  ]],
Cell[47734, 1351, 254, 5, 124, "Text"],
Cell[47991, 1358, 271, 5, 112, "Input"],
Cell[48265, 1365, 83, 1, 60, "Text"],

Cell[CellGroupData[{
Cell[48373, 1370, 409, 8, 202, "Input"],
Cell[48785, 1380, 38, 1, 77, "Output"]
}, Open  ]],
Cell[48838, 1384, 151, 3, 92, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[49038, 1393, 77, 0, 78, "Subsection"],
Cell[49118, 1395, 104, 3, 60, "Text"],
Cell[49225, 1400, 60, 1, 52, "Input"],
Cell[49288, 1403, 66, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[49379, 1407, 53, 1, 52, "Input"],
Cell[49435, 1410, 11839, 292, 466, "Print"]
}, Open  ]],
Cell[61289, 1705, 523, 9, 252, "Text"],

Cell[CellGroupData[{
Cell[61837, 1718, 214, 4, 112, "Input"],
Cell[62054, 1724, 260, 7, 84, "Output"]
}, Open  ]],
Cell[62329, 1734, 74, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[62428, 1738, 79, 1, 52, "Input"],
Cell[62510, 1741, 301, 7, 84, "Output"]
}, Open  ]],
Cell[62826, 1751, 216, 6, 92, "Text"],
Cell[63045, 1759, 101, 3, 60, "Text"],
Cell[63149, 1764, 55, 1, 52, "Input"],

Cell[CellGroupData[{
Cell[63229, 1769, 85, 1, 52, "Input"],
Cell[63317, 1772, 509, 15, 84, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[63863, 1792, 88, 1, 52, "Input"],
Cell[63954, 1795, 673, 18, 84, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[64664, 1818, 221, 4, 112, "Input"],
Cell[64888, 1824, 509, 15, 84, "Output"]
}, Open  ]],
Cell[65412, 1842, 245, 5, 124, "Text"],

Cell[CellGroupData[{
Cell[65682, 1851, 88, 1, 52, "Input"],
Cell[65773, 1854, 856, 22, 84, "Output"]
}, Open  ]],
Cell[66644, 1879, 459, 8, 188, "Text"],

Cell[CellGroupData[{
Cell[67128, 1891, 76, 1, 52, "Input"],
Cell[67207, 1894, 3583, 93, 162, "Output"]
}, Open  ]],
Cell[70805, 1990, 174, 4, 92, "Text"],

Cell[CellGroupData[{
Cell[71004, 1998, 196, 3, 112, "Input"],
Cell[71203, 2003, 39, 1, 80, "Output"]
}, Open  ]],
Cell[71257, 2007, 170, 4, 92, "Text"],

Cell[CellGroupData[{
Cell[71452, 2015, 112, 4, 52, "Subsubsection"],
Cell[71567, 2021, 527, 13, 380, "Text"],
Cell[72097, 2036, 44, 1, 52, "Input"],
Cell[72144, 2039, 174, 3, 112, "Input"],
Cell[72321, 2044, 112, 3, 60, "Text"],

Cell[CellGroupData[{
Cell[72458, 2051, 93, 1, 52, "Input"],
Cell[72554, 2054, 68, 1, 59, "Output"]
}, Open  ]],
Cell[72637, 2058, 79, 0, 60, "Text"],
Cell[72719, 2060, 102, 2, 82, "Input"],
Cell[72824, 2064, 96, 3, 60, "Text"],

Cell[CellGroupData[{
Cell[72945, 2071, 64, 1, 52, "Input"],
Cell[73012, 2074, 495, 16, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[73544, 2095, 76, 1, 52, "Input"],
Cell[73623, 2098, 721, 23, 59, "Output"]
}, Open  ]],
Cell[74359, 2124, 341, 6, 156, "Text"],

Cell[CellGroupData[{
Cell[74725, 2134, 66, 1, 52, "Input"],
Cell[74794, 2137, 1454, 39, 47, "Print"],
Cell[76251, 2178, 2188, 64, 59, "Output"]
}, Open  ]],
Cell[78454, 2245, 227, 5, 124, "Text"],

Cell[CellGroupData[{
Cell[78706, 2254, 75, 1, 52, "Input"],
Cell[78784, 2257, 608, 19, 80, "Output"]
}, Open  ]],
Cell[79407, 2279, 323, 9, 124, "Text"],

Cell[CellGroupData[{
Cell[79755, 2292, 69, 1, 52, "Input"],
Cell[79827, 2295, 449, 13, 80, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[80313, 2313, 78, 1, 52, "Input"],
Cell[80394, 2316, 77, 1, 108, "Output"]
}, Open  ]],
Cell[80486, 2320, 121, 3, 60, "Text"],

Cell[CellGroupData[{
Cell[80632, 2327, 81, 1, 52, "Input"],
Cell[80716, 2330, 83, 1, 108, "Output"]
}, Open  ]],
Cell[80814, 2334, 123, 3, 92, "Text"],

Cell[CellGroupData[{
Cell[80962, 2341, 80, 1, 52, "Input"],
Cell[81045, 2344, 103, 2, 108, "Output"]
}, Open  ]],
Cell[81163, 2349, 200, 6, 156, "Text"],

Cell[CellGroupData[{
Cell[81388, 2359, 124, 2, 52, "Input"],
Cell[81515, 2363, 62, 1, 84, "Output"]
}, Open  ]],
Cell[81592, 2367, 79, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[81696, 2371, 67, 1, 52, "Input"],
Cell[81766, 2374, 40, 1, 77, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

